; **************************************************************************
; **                  LibraryDesigner 1.0 for PureBasic                   **
; **                 by Timo 'fr34k' Harter - 12/18/2003                  **
; **************************************************************************

; This code is free for everybody to use and learn from, whoever invests 
; his time to make sense out of this code may also use it ;) 
; Make sure to read the provided Readme.txt for more Info on this program.
; Many thanks go to El_Choni, for providing us with his MDI example, which
; helped me a lot here.

;- Top
Enumeration
  #WINDOW_Main
  #WINDOW_Preferences  
  #WINDOW_Browser
  #WINDOW_Output
  #WINDOW_Splitter  
  #WINDOW_Compiler
  #WINDOW_Options
  #WINDOW_Find
  #WINDOW_Goto  
  #WINDOW_Syntax
EndEnumeration

Enumeration
  #GADGET
 
  #GADGET_Browser
  #GADGET_Output
  
  #GADGET_Prefs_Lcc
  #GADGET_Prefs_GetLcc
  #GADGET_Prefs_LibMaker
  #GADGET_Prefs_GetLccLib
  #GADGET_Prefs_LccLib
  #GADGET_Prefs_GetLibMaker
  #GADGET_Prefs_Temp
  #GADGET_Prefs_GetTemp
  #GADGET_Prefs_UserLib
  #GADGET_Prefs_GetUserLib
  #GADGET_Prefs_Use
  #GADGET_Prefs_Abort 
  
  #GADGET_Opt_Desc
  #GADGET_Opt_GetDesc
  #GADGET_Opt_FileList
  #GADGET_Opt_File
  #GADGET_Opt_Add
  #GADGET_Opt_Remove
  #GADGET_Opt_GetFile
  #GADGET_Opt_Compress
  #GADGET_Opt_Define
  #GADGET_Opt_WriteInfo
  #GADGET_Opt_Abort
  #GADGET_Opt_Use 
  
  #GADGET_Find_String
  #GADGET_Find_DoReplace
  #GADGET_Find_NewString
  #GADGET_Find_Next
  #GADGET_Find_Replace
  #GADGET_Find_Replaceall
  #GADGET_Find_Close
  #GADGET_Find_Case
  #GADGET_Find_Words
  #GADGET_Find_NoComment
  #GADGET_Find_NoString
  #GADGET_Find_SelOnly
  #GADGET_Find_Up
  #GADGET_Find_Down
  
  #GADGET_Goto_Line
  #GADGET_Goto_Ok
  #GADGET_Goto_Abort
  
  #GADGET_Compiler_Info
  #GADGET_Compiler_Abort  
EndEnumeration

Enumeration
  #MENU_File_New
  #MENU_File_Open
  #MENU_File_Save
  #MENU_File_SaveAs
  #MENU_File_Close
  #MENU_File_CloseAll
  #MENU_File_Preferences
  #MENU_File_Quit
  
  #MENU_Edit_Undo
  #MENU_Edit_Redo
  #MENU_Edit_Cut
  #MENU_Edit_Copy
  #MENU_Edit_Paste
  #MENU_Edit_Refresh
  #MENU_Edit_Goto
  #MENU_Edit_Find
  #MENU_Edit_FindNext

  #MENU_Compiler_Compile
  #MENU_Compiler_Check
  #MENU_Compiler_Options

  #MENU_Output_Tool
  #MENU_Output_Docked
  #MENU_Output_Child
  #MENU_Output_Hide

  #MENU_Browser_Tool
  #MENU_Browser_Docked
  #MENU_Browser_Child
  #MENU_Browser_Hide
  
  #MENU_TileVertical
  #MENU_TileHorizontal
  #MENU_Cascade
  
  #MENU_Shortcut_Return
  #MENU_Shortcut_Escape

  #MENU_FirstChild
EndEnumeration

Enumeration
  #IMAGE_Cascade
  #IMAGE_TileVertical
  #IMAGE_TileHorizontal
  #IMAGE_Check
  #IMAGE_Compile
  #IMAGE_File
  #IMAGE_FileChanged
  #IMAGE_Refresh
EndEnumeration

#SUBMENU_Windows = 3

#STATUSBAR = 0
#TOOLBAR = 0
#MAINMENU = 0
#POPUPMENU = 1
#FONT = 0

#FILE_Load = 0
#FILE_Save = 1
#FILE_ErrorLog = 2

#MEMORY_Syntax = 0
#MEMORY_Parser = 1

#COLOR_Text = $000000
#COLOR_Keyword = $0000C0
#COLOR_Comment = $808080

#MAX_FILES = 30
#MAX_Browser = 300
#MAX_Output = 300

#Keywords = 28 ; 0 based!

; for Text Object Model in RichEdit 3.0
#tomSuspend = -9999995
#tomResume  = -9999994

Structure FileInfo
  *MDIWindow
  *Richedit
  
  OleObject.l
  TextObject.l
  
  FullFileName$
  FileName$
  
  ChangeIcon.l
  IsCFile.l  
  
  WriteInfo.l
  Define$
  DescFile$
  Compress.l

  UsedFileCount.l
  UsedFiles$[#MAX_FILES]
  
  BrowserCount.l
  BrowserList$[#MAX_Browser]
  BrowserLines.l[#MAX_Browser]  
  
  OutputCount.l
  OutputList$[#MAX_Output]
  OutputLines.l[#MAX_Output]
EndStructure

Declare CheckSyntax()
Declare CheckSyntaxEnd()
Declare StartCompilation()
Declare ContinueCompilation()
Declare StopCompilation(Message$)
Declare FindText(Mode)
Declare ScanBrowser()
Declare RefreshStatusBar()
Declare HilightLine()
Declare HilightFile()
Declare NewFile()
Declare LoadFile(FileName$)
Declare SaveFile(*File.FileInfo)
Declare SaveFileAs(*File.FileInfo)
Declare RemoveFile(*File.FileInfo)
Declare SetCurrentFile()
Declare UpdateBrowser(NewState)
Declare UpdateOutput(NewState)
Declare MakeToolWindow(WindowID)
Declare Enum_CloseFiles(Window, lParam)
Declare Richedit_StreamCallback(dwCookie.l, pbBuff.l, cb.l, *pcb.LONG)
Declare Richedit_StreamToMemory(dwCookie.l, pbBuff.l, cb.l, *pcb.LONG)
Declare WindowCallback(Window, Message, wParam, lParam)
Declare MDI_FrameProc(Window, Message, wParam, lParam)
Declare MDI_ChildProc(Window, Message, wParam, lParam)
Declare Open_WINDOW_Preferences()
Declare Open_WINDOW_Options()
Declare Open_WINDOW_Find()
Declare Open_WINDOW_Goto()
Declare Open_WINDOW_Compiler()
Declare Open_WINDOW_Syntax()

NewList File.FileInfo()

Dim LastFiles$(99)
Dim KeyWord$(#Keywords)
Dim KeyWordLength.l(#KeyWords)
Dim IsValidChar.l(255)

Dim CreatedTempFiles$(99)
Dim CompileFiles$(99)

Global *MainWindow, *MainMenu, *ClientWindow, *Toolbar, *StatusBar, Quit

Global MainX, MainY, MainWidth, MainHeight, IsMainMaximized

Global BrowserToolX, BrowserToolY, BrowserToolWidth, BrowserToolHeight
Global BrowserMDIX, BrowserMDIY, BrowserMDIWidth, BrowserMDIHeight
Global BrowserSplitter, BrowserState, *MDIBrowser

Global OutputToolX, OutputToolY, OutputToolWidth, OutputToolHeight
Global OutputMDIX, OutputMDIY, OutputMDIWidth, OutputMDIHeight
Global OutputSplitter, OutputState, *MDIOutput

Global LccPath$, LccLibPath$, LibMakerPath$, TempPath$, UserLibPath$, IsChildMaximized

Global SplitterXCursor, SplitterYCursor, SplitterXActive, SplitterYActive

Global CurrentFile$, LastSelectedPattern, NoCurrentFileUpdate, OpenFiles, *SyntaxBuffer.BYTE, *ParseBuffer.BYTE, *RichEdit
Global LoadingFile, IgnoreReturnMessage, *StreamTarget
Global SearchString$, ReplaceString$, SearchCase, SearchWords, SearchDoReplace, SearchSel, SearchNoString, SearchNoComment

Global Compiling, CheckSyntax, TempFiles, CompileFiles, CurrentFile, CompilerHandle, CompileStatus
Global CompileLibName$



;- Startup

LoadLibrary_("RICHED20.DLL")

Restore SyntaxList
For i = 0 To #KeyWords
  Read Keyword$(i)
  KeyWordLength(i) = Len(KeyWord$(i))
Next i

*SyntaxBuffer = AllocateMemory(#MEMORY_Syntax, 3000)
If *SyntaxBuffer = 0
  MessageRequester("LibraryDesigner", "Can't allocate 3000bytes of memory!"+Chr(13)+"You should definately buy yourself some more RAM!!")
  End
EndIf

For i = 'A' To 'Z'
  IsValidChar(i) = 1
Next i

For i = 'a' To 'z'
  IsValidChar(i) = 1
Next i

For i = '0' To '9'
  IsValidChar(i) = 1
Next i

IsVAlidChar('#') = 1
IsValidChar('_') = 1


LoadFont(#FONT, "Courier", 10)

SplitterXCursor = LoadCursor_(0, #IDC_SIZEWE)
SplitterYCursor = LoadCursor_(0, #IDC_SIZENS)

CatchImage(#IMAGE_File, ?Image_File)
CatchImage(#IMAGE_FileChanged, ?Image_FileChanged)

OpenPreferences("LibraryDesigner.prefs")
  PreferenceGroup("EDITOR")
    MainX           = ReadPreferenceLong("MainX", GetSystemMetrics_(#SM_CXSCREEN)/2-400)
    MainY           = ReadPreferenceLong("MainY", GetSystemMetrics_(#SM_CYSCREEN)/2-300)
    MainWidth       = ReadPreferenceLong("MainWidth", 800)
    MainHeight      = ReadPreferenceLong("MainHeight", 600)
    IsMainMaximized = ReadPreferenceLong("IsMainMaximized", 0)
    
    BrowserToolX      = ReadPreferenceLong("BrowserToolX", GetSystemMetrics_(#SM_CXSCREEN)/2+200)
    BrowserToolY      = ReadPreferenceLong("BrowserToolY", GetSystemMetrics_(#SM_CYSCREEN)/2-255)
    BrowserToolWidth  = ReadPreferenceLong("BrowserToolWidth", 200)
    BrowserToolHeight = ReadPreferenceLong("BrowserToolHeight", 555)
    BrowserMDIX       = ReadPreferenceLong("BrowserMDIX", 50)
    BrowserMDIY       = ReadPreferenceLong("BrowserMDIY", 50)
    BrowserMDIWidth   = ReadPreferenceLong("BrowserMDIWidth", 300)
    BrowserMDIHeight  = ReadPreferenceLong("BrowserMDIHeight", 400)
    BrowserSplitter   = ReadPreferenceLong("BrowserSplitter", 120)
    BrowserNewState   = ReadPreferenceLong("BrowserState", 1)
    BrowserState      = -1
    
    OutputToolX      = ReadPreferenceLong("OutputToolX", GetSystemMetrics_(#SM_CXSCREEN)/2-398)
    OutputToolY      = ReadPreferenceLong("OutputToolY", GetSystemMetrics_(#SM_CYSCREEN)/2+148)
    OutputToolWidth  = ReadPreferenceLong("OutputToolWidth", 595)
    OutputToolHeight = ReadPreferenceLong("OutputToolHeight", 150)
    OutputMDIX       = ReadPreferenceLong("OutputMDIX", 80)
    OutputMDIY       = ReadPreferenceLong("OutputMDIY", 80)
    OutputMDIWidth   = ReadPreferenceLong("OutputMDIWidth", 300)
    OutputMDIHeight  = ReadPreferenceLong("OutputMDIHeight", 400)
    OutputSplitter   = ReadPreferenceLong("OutputSplitter", 100)
    OutputNewState   = ReadPreferenceLong("OutputState", 1)
    OutputState      = -1  
    
  PreferenceGroup("PREFS")
    LccPath$         = ReadPreferenceString("LccPath","")
    LccLibPath$      = ReadPreferenceString("LccLibPath","")
    LibMakerPath$    = ReadPreferenceString("LibMakerPath","")
    TempPath$        = ReadPreferenceString("TempPath","")
    UserLibPath$     = ReadPreferenceString("UserLibPath","")
    
  PreferenceGroup("FILES")
    OpenFiles        = ReadPreferenceLong("OpenFiles", 0)    
    IsChildMaximized = ReadPreferenceLong("IsChildMaximized", 0)   
    For i = 1 To OpenFiles
      LastFiles$(i)  = ReadPreferenceString("File_"+Str(i), "")
    Next i

ClosePreferences()

;- Create GUI
If OpenWindow(#WINDOW_Main, MainX, MainY, MainWidth, MainHeight, #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGAdget|#PB_Window_SizeGadget|#PB_Window_Invisible, "LibraryDesigner")
  *MainWindow = WindowID()
  
  RemoveKeyboardShortcut(#WINDOW_Main,-1)

  *MainMenu = CreateMenu(#MAINMENU, WindowID())
    MenuTitle("File")
      MenuItem(#MENU_File_New, "New"+Chr(9)+"Ctrl+N")
      MenuItem(#MENU_File_Open, "Open"+Chr(9)+"Ctrl+O")
      MenuItem(#MENU_File_Save, "Save"+Chr(9)+"Ctrl+S")
      MenuItem(#MENU_File_SaveAs, "Save As")
      MenuBar()
      MenuItem(#MENU_File_Close, "Close"+Chr(9)+"Ctrl+W")
      MenuItem(#MENU_File_CloseAll, "Close All")
      MenuBar()
      MenuItem(#MENU_File_Preferences,"Preferences")
      MenuBar()
      MenuItem(#MENU_File_Quit,"Quit"+Chr(9)+"Alt+F4")
  
  
    MenuTitle("Edit")
      MenuItem(#MENU_Edit_Undo, "Undo"+Chr(9)+"Ctrl+Z")
      MenuItem(#MENU_Edit_Redo, "Redo"+Chr(9)+"Ctrl+Y")
      MenuBar()
      MenuItem(#MENU_Edit_Cut, "Cut"+Chr(9)+"Ctrl+X")
      MenuItem(#MENU_Edit_Copy, "Copy"+Chr(9)+"Ctrl+C")
      MenuItem(#MENU_Edit_Paste, "Paste"+Chr(9)+"Ctrl+V")
      MenuBar()
      MenuItem(#MENU_Edit_Refresh, "Refresh Syntax Hilighting"+Chr(9)+"Ctrl+R")
      MenuBar()
      MenuItem(#MENU_Edit_Goto, "Goto..."+Chr(9)+"Ctrl+G")
      MenuBar()
      MenuItem(#MENU_Edit_Find, "Find/Replace"+Chr(9)+"Ctrl+F")
      MenuItem(#MENU_Edit_FindNext, "Find Next"+Chr(9)+"F3")
      
    MenuTitle("Compiler")
      MenuItem(#MENU_Compiler_Compile, "Compile"+Chr(9)+"F5")
      MenuItem(#MENU_Compiler_Check, "Check Syntax"+Chr(9)+"F9")
      MenuBar()
      MenuItem(#MENU_Compiler_Options, "Compiler Options")
      MenuBar()
      OpenSubMenu("Compiler Output")
        MenuItem(#MENU_Output_Tool, "ToolWindow")
        MenuItem(#MENU_Output_Docked, "Docked")
        MenuItem(#MENU_Output_Child, "MDI Window")
        MenuItem(#MENU_Output_Hide, "Hide")
      CloseSubMenu()
      OpenSubMenu("Procedure Browser")
        MenuItem(#MENU_Browser_Tool, "ToolWindow")
        MenuItem(#MENU_Browser_Docked, "Docked")
        MenuItem(#MENU_Browser_Child, "MDI Window")
        MenuItem(#MENU_Browser_Hide, "Hide")
      CloseSubMenu()
          
    MenuTitle("Windows")  
      MenuItem(#MENU_TileVertical,"Tile vertically")
      MenuItem(#MENU_TileHorizontal, "Tile horizontally")
      MenuItem(#MENU_Cascade, "Cascade Windows")
      
  CreatePopupMenu(#POPUPMENU)
    MenuItem(#MENU_Edit_Cut, "Cut"+Chr(9)+"Ctrl+X")
    MenuItem(#MENU_Edit_Copy, "Copy"+Chr(9)+"Ctrl+C")
    MenuItem(#MENU_Edit_Paste, "Paste"+Chr(9)+"Ctrl+V")
    MenuBar()
    MenuItem(#MENU_Edit_Find, "Find/Replace"+Chr(9)+"Ctrl+F")
    MenuItem(#MENU_Edit_FindNext, "Find Next"+Chr(9)+"F3")
      
      
  *ToolBar = CreateToolBar(#TOOLBAR, *MainWindow)
    ToolBarStandardButton(#MENU_File_New, #PB_ToolBarIcon_New)
    ToolBarStandardButton(#MENU_File_Open, #PB_ToolBarIcon_Open)
    ToolBarStandardButton(#MENU_File_Save, #PB_ToolBarIcon_Save)
    ToolBarSeparator() 
    ToolBarStandardButton(#MENU_File_Close, #PB_ToolBarIcon_Delete)
    ToolBarSeparator() 
    ToolBarStandardButton(#MENU_Edit_Undo, #PB_ToolBarIcon_Undo)
    ToolBarStandardButton(#MENU_Edit_Redo, #PB_ToolBarIcon_Redo)
    ToolBarSeparator()
    ToolBarStandardButton(#MENU_Edit_Cut, #PB_ToolBarIcon_Cut)
    ToolBarStandardButton(#MENU_Edit_Copy, #PB_ToolBarIcon_Copy)
    ToolBarStandardButton(#MENU_Edit_Paste, #PB_ToolBarIcon_Paste)
    ToolBarSeparator()
    ToolBarStandardButton(#MENU_Edit_Find, #PB_ToolBarIcon_Find)
    ToolBarSeparator()
    ToolBarImageButton(#MENU_Edit_Refresh, CatchImage(#IMAGE_Refresh, ?Image_Refresh))
    ToolBarSeparator()
    ToolBarImageButton(#MENU_TileVertical, CatchImage(#IMAGE_TileVertical, ?Image_TileVertical))
    ToolBarImageButton(#MENU_TileHorizontal, CatchImage(#IMAGE_TileHorizontal, ?Image_TileHorizontal))
    ToolBarImageButton(#MENU_Cascade, CatchImage(#IMAGE_Cascade, ?Image_Cascade))
    ToolBarSeparator()
    ToolBarStandardButton(#MENU_Compiler_Options, #PB_ToolBarIcon_Properties)
    ToolBarImageButton(#MENU_Compiler_Check, CatchImage(#IMAGE_Check, ?Image_Check))    
    ToolBarImageButton(#MENU_Compiler_Compile, CatchImage(#IMAGE_Compile, ?Image_Compile))

    ToolBarToolTip(#MENU_File_New, "New")
    ToolBarToolTip(#MENU_File_Open, "Open")
    ToolBarToolTip(#MENU_File_Save, "Save")
    ToolBarToolTip(#MENU_File_Close, "Close")
    ToolBarToolTip(#MENU_Edit_Undo, "Undo")
    ToolBarToolTip(#MENU_Edit_Redo, "Redo")
    ToolBarToolTip(#MENU_Edit_Cut, "Cut")
    ToolBarToolTip(#MENU_Edit_Copy, "Copy")
    ToolBarToolTip(#MENU_Edit_Paste, "Paste")
    ToolBarToolTip(#MENU_Edit_Refresh, "Refresh Syntax Hilighting")
    ToolBarToolTip(#MENU_Edit_Find, "Find/Replace")
    ToolBarToolTip(#MENU_TileVertical, "Tile Windows vertically")
    ToolBarToolTip(#MENU_TileHorizontal, "Tile Windows horizontally")
    ToolBarToolTip(#MENU_Cascade, "Cascade Windows")
    ToolBarToolTip(#MENU_Compiler_Options, "Compiler options")
    ToolBarToolTip(#MENU_Compiler_Check, "Check syntax")
    ToolBarToolTip(#MENU_Compiler_Compile, "Compile")
  

  *StatusBar = CreateStatusBar(#STATUSBAR, *MainWindow)
    AddStatusBarField(150)
 
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_N, #MENU_File_New)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_O, #MENU_File_Open)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_S, #MENU_File_Save)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_W, #MENU_File_Close)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_Z, #MENU_Edit_Undo)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_Y, #MENU_Edit_Redo)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_X, #MENU_Edit_Cut)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_C, #MENU_Edit_Copy)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_V, #MENU_Edit_Paste)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_G, #MENU_Edit_Goto)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_F, #MENU_Edit_Find)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_Control|#PB_Shortcut_R, #MENU_Edit_Refresh)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_F3, #MENU_Edit_FindNext)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_F5, #MENU_Compiler_Compile)
  AddKeyboardShortcut(#WINDOW_Main, #PB_Shortcut_F9, #MENU_Compiler_Check)    
  
  SetWindowCallback(@WindowCallback())    
  SetWindowLong_(*MainWindow, #GWL_WNDPROC, @MDI_FrameProc())
             
  Class.WNDCLASSEX
  Class\cbSize = SizeOf(WNDCLASSEX)
  Class\style = #CS_HREDRAW|#CS_VREDRAW|#CS_BYTEALIGNWINDOW
  Class\hbrBackground = #COLOR_BTNFACE+1
  Class\lpszMenuName = #NULL
  Class\lpfnWndProc = @MDI_ChildProc()
  Class\hInstance = GetModuleHandle_(0)
  Class\lpszClassName = @"MDI_ChildClass"
  Class\hIcon = UseImage(#IMAGE_File)
  Class\hIconSm = UseImage(#IMAGE_File)
  RegisterClassEx_(@Class)    
    
  cs.CLIENTCREATESTRUCT
  cs\hWindowMenu = GetSubMenu_(GetMenu_(*MainWindow), #SUBMENU_Windows)
  cs\idFirstChild = #MENU_FirstChild
  
  *ClientWindow = CreateWindowEx_(#WS_EX_CLIENTEDGE, @"MDICLIENT", #NULL, #WS_CHILD|#WS_CLIPCHILDREN|#WS_VISIBLE|#WS_VSCROLL|#WS_HSCROLL, 0, 0, 0, 0, *MainWindow, $CAC, GetModuleHandle_(0), @cs)      
  
  OpenWindow(#WINDOW_Splitter, 0, 0, 0, 0, #PB_Window_Borderless|#PB_Window_Invisible, "")
  SetWindowLong_(WindowID(#WINDOW_Splitter), #GWL_EXSTYLE, GetWindowLong_(WindowID(#WINDOW_Splitter), #GWL_EXSTYLE) | #WS_EX_CLIENTEDGE)
  SetParent_(WindowID(#WINDOW_Splitter), *MainWindow)  
    
  UpdateBrowser(BrowserNewState)
  UpdateOutput(OutputNewState) 
    
  If LccPath$ = ""
    Open_WINDOW_Preferences()
  EndIf
  
  For i = OpenFiles To 1 Step -1
    LoadFile(LastFiles$(i))
  Next i
  
  SetCurrentFile() 
  
  If OpenFiles And IsChildMaximized
    SendMessage_(*ClientWindow, #WM_MDIMAXIMIZE, File()\MDIWindow, 0)
  EndIf
  
  OpenFiles = 0
  
  If IsMainMaximized
    ShowWindow_(*MainWindow, #SW_MAXIMIZE)
  Else
    ShowWindow_(*MainWindow, #SW_SHOWNORMAL)
  EndIf  

  ;- Loop
  Quit = 0
  Repeat    
    If Compiling
      EventID = WindowEvent()
      
      ExitCode = 0
      GetExitCodeProcess_(CompilerHandle, @ExitCode)
      If ExitCode <> #STATUS_PENDING
        ContinueCompilation()
      EndIf
      
      If EventID = 0 And ExitCode = #STATUS_PENDING
        Delay(1)
      EndIf
      
    ElseIf CheckSyntax
      EventID = WindowEvent()
      
      ExitCode = 0
      GetExitCodeProcess_(CompilerHandle, @ExitCode)
      If ExitCode <> #STATUS_PENDING
        CheckSyntaxEnd()
      EndIf
      
      If EventID = 0 And ExitCode = #STATUS_PENDING
        Delay(1)
      EndIf
      
    Else
      EventID = WaitWindowEvent()
      
    EndIf 
    
    Select EventWindowID()
    
      ;- Compiler Events
      Case #WINDOW_Compiler
        If EventID = #PB_EventGadget And EventGadgetID() = #GADGET_Compiler_Abort
          StopCompilation("Aborted on User request.")
        EndIf
    
      ;- Output Events
      Case #WINDOW_Output
        If EventID = #PB_EventCloseWindow
          UpdateOutput(3) ; hide
          
        ElseIf EventID = #PB_EventGadget And EventGadgetID() = #GADGET_Output
          If EventType() = #PB_EventType_LeftClick Or EventType() = #PB_EventType_LeftDoubleClick 
            Item = GetGadgetState(#GADGET_Output)
            If Item <> -1    
              If File()\OutputLines[Item] <> -1
                SendMessage_(*RichEdit, #EM_LINESCROLL, 0, -20000)
                SendMessage_(*RichEdit, #EM_LINESCROLL, 0, File()\OutputLines[Item]-3)
                Sel.CHARRANGE
                Sel\cpMin = SendMessage_(*RichEdit, #EM_LINEINDEX, File()\OutputLines[Item], 0)
                Sel\cpMax = Sel\cpMin
                SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
                SetFocus_(*RichEdit)
              EndIf
            EndIf
          EndIf        
        EndIf
      
      ;- Browser Events  
      Case #WINDOW_Browser
        If EventID = #PB_EventCloseWindow
          UpdateBrowser(3) ; hide
          
        ElseIf EventID = #PB_EventGadget And EventGadgetID() = #GADGET_Browser
          If EventType() = #PB_EventType_LeftClick Or EventType() = #PB_EventType_LeftDoubleClick 
            Item = GetGadgetState(#GADGET_Browser)
            If Item <> -1     
              SendMessage_(*RichEdit, #EM_LINESCROLL, 0, -20000)
              SendMessage_(*RichEdit, #EM_LINESCROLL, 0, File()\BrowserLines[Item])
              Sel.CHARRANGE
              Sel\cpMin = SendMessage_(*RichEdit, #EM_LINEINDEX, File()\BrowserLines[Item], 0)
              Sel\cpMax = Sel\cpMin
              SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
              SetFocus_(*RichEdit)
            EndIf
          EndIf
        EndIf    
        
      ;- Goto Window Events
      Case #WINDOW_Goto
        If EventID = #PB_EventCloseWindow
          CloseWindow(#WINDOW_Goto)
        
        ElseIf EventID = #PB_EventMenu 
          Select EventMenuID()
            Case #MENU_Shortcut_Return                
              Line = Val(GetGadgetText(#GADGET_Goto_Line))
              CloseWindow(#WINDOW_Goto)
              SendMessage_(*RichEdit, #EM_LINESCROLL, 0, -20000)
              SendMessage_(*RichEdit, #EM_LINESCROLL, 0, Line)    
              Sel.CHARRANGE
              Sel\cpMin = SendMessage_(*RichEdit, #EM_LINEINDEX, Line, 0)
              Sel\cpMax = Sel\cpMin
              SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
              SetFocus_(*RichEdit)
              
            Case #MENU_Shortcut_Escape
              CloseWindow(#WINDOW_Goto)
              
          EndSelect
          
        ElseIf EventID = #PB_EventGadget
          Select EventGadgetID()
            Case #GADGET_Goto_Ok
              Line = Val(GetGadgetText(#GADGET_Goto_Line))
              CloseWindow(#WINDOW_Goto)
              SendMessage_(*RichEdit, #EM_LINESCROLL, 0, -20000)
              SendMessage_(*RichEdit, #EM_LINESCROLL, 0, Line)    
              Sel.CHARRANGE
              Sel\cpMin = SendMessage_(*RichEdit, #EM_LINEINDEX, Line, 0)
              Sel\cpMax = Sel\cpMin
              SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
              SetFocus_(*RichEdit)
            
            Case #GADGET_Goto_Abort
              CloseWindow(#WINDOW_Goto)
          EndSelect
        
        EndIf
        
      ;- Find Window Events
      Case #WINDOW_Find
        If EventID = #PB_EventCloseWindow
          CloseWindow(#WINDOW_Find)
      
        ElseIf EventID = #PB_EventMenu 
          Select EventMenuID()
            Case #MENU_Shortcut_Return
              SearchString$     = GetGadgetText(#GADGET_Find_String)
              ReplaceString$    = GetGadgetText(#GADGET_Find_NewString)
              SearchDoReplace   = GetGadgetState(#GADGET_Find_DoReplace)
              SearchCase        = GetGadgetState(#GADGET_Find_Case)
              SearchWords       = GetGadgetState(#GADGET_Find_Words)
              SearchNoComment   = GetGadgetState(#GADGET_Find_NoComment)
              SearchNoString    = GetGadgetState(#GADGET_Find_NoString)
              SearchSel         = GetGadgetState(#GADGET_Find_SelOnly)
              FindText(1)        
              
            Case #MENU_Shortcut_Escape
              CloseWindow(#WINDOW_Find)
              
          EndSelect
        
        ElseIf EventID = #PB_EventGadget
          Select EventGadgetID()
          
            Case #GADGET_Find_DoReplace
              If GetGadgetState(#GADGET_Find_DoReplace)
                DisableGadget(#GADGET_Find_NewString, #FALSE)
                DisableGadget(#GADGET_Find_Replace, #FALSE)
                DisableGadget(#GADGET_Find_Replaceall, #FALSE)
              Else
                DisableGadget(#GADGET_Find_NewString, #TRUE)
                DisableGadget(#GADGET_Find_Replace, #TRUE)
                DisableGadget(#GADGET_Find_Replaceall, #TRUE)
              EndIf
              
            Case #GADGET_Find_Next
              SearchString$     = GetGadgetText(#GADGET_Find_String)
              ReplaceString$    = GetGadgetText(#GADGET_Find_NewString)
              SearchDoReplace   = GetGadgetState(#GADGET_Find_DoReplace)
              SearchCase        = GetGadgetState(#GADGET_Find_Case)
              SearchWords       = GetGadgetState(#GADGET_Find_Words)
              SearchNoComment   = GetGadgetState(#GADGET_Find_NoComment)
              SearchNoString    = GetGadgetState(#GADGET_Find_NoString)
              SearchSel         = GetGadgetState(#GADGET_Find_SelOnly)
              FindText(1)
            
            Case #GADGET_Find_Replace
              SearchString$     = GetGadgetText(#GADGET_Find_String)
              ReplaceString$    = GetGadgetText(#GADGET_Find_NewString)
              SearchDoReplace   = GetGadgetState(#GADGET_Find_DoReplace)
              SearchCase        = GetGadgetState(#GADGET_Find_Case)
              SearchWords       = GetGadgetState(#GADGET_Find_Words)
              SearchNoComment   = GetGadgetState(#GADGET_Find_NoComment)
              SearchNoString    = GetGadgetState(#GADGET_Find_NoString)
              SearchSel         = GetGadgetState(#GADGET_Find_SelOnly)
              FindText(2)
            
            Case #GADGET_Find_ReplaceAll
              SearchString$     = GetGadgetText(#GADGET_Find_String)
              ReplaceString$    = GetGadgetText(#GADGET_Find_NewString)
              SearchDoReplace   = GetGadgetState(#GADGET_Find_DoReplace)
              SearchCase        = GetGadgetState(#GADGET_Find_Case)
              SearchWords       = GetGadgetState(#GADGET_Find_Words)
              SearchNoComment   = GetGadgetState(#GADGET_Find_NoComment)
              SearchNoString    = GetGadgetState(#GADGET_Find_NoString)
              SearchSel         = GetGadgetState(#GADGET_Find_SelOnly)
              FindText(3)
              CloseWindow(#WINDOW_Find)
          
            Case #GADGET_Find_Close
              CloseWindow(#WINDOW_Find)                
          
          EndSelect
        EndIf    
      
      ;- Preferences Events  
      Case #WINDOW_Preferences
        If EventID = #PB_EventCloseWindow
          CloseWindow(#WINDOW_Preferences)
          
        ElseIf EventID = #PB_EventMenu
          Select EventMenuID()                   
            Case #MENU_Shortcut_Return
              LccPath$      = GetGadgetText(#GADGET_Prefs_Lcc)
              LccLibPath$   = GetGadgetText(#GADGET_Prefs_LccLib)
              LibMakerPath$ = GetGadgetText(#GADGET_Prefs_LibMaker)
              TempPath$     = GetGadgetText(#GADGET_Prefs_Temp)
              UserLibPath$  = GetGadgetText(#GADGET_Prefs_USerLib)
              CloseWindow(#WINDOW_Preferences)
            
            Case #MENU_Shortcut_Escape
              CloseWindow(#WINDOW_Preferences)
          EndSelect
          
        ElseIf EventID = #PB_EventGadget
          Select EventGadgetID()
          
            Case #GADGET_Prefs_Use
              LccPath$      = GetGadgetText(#GADGET_Prefs_Lcc)
              LccLibPath$   = GetGadgetText(#GADGET_Prefs_LccLib)
              LibMakerPath$ = GetGadgetText(#GADGET_Prefs_LibMaker)
              TempPath$     = GetGadgetText(#GADGET_Prefs_Temp)
              UserLibPath$  = GetGadgetText(#GADGET_Prefs_USerLib)
              CloseWindow(#WINDOW_Preferences)
            
            Case #GADGET_Prefs_Abort
              CloseWindow(#WINDOW_Preferences)
            
            Case #GADGET_Prefs_GetLcc
              Text$ = OpenFileRequester("Select Lcc.exe ...", GetGadgetText(#GADGET_Prefs_Lcc), "Exe Files (*.exe)|*.exe|All Files (*.*)|*.*", 0)
              If Text$ <> "": SetGadgetText(#GADGET_Prefs_Lcc, Text$): EndIf
            
            Case #GADGET_Prefs_GetLccLib
              Text$ = OpenFileRequester("Select LccLib.exe ...", GetGadgetText(#GADGET_Prefs_LccLib), "Exe Files (*.exe)|*.exe|All Files (*.*)|*.*", 0)
              If Text$ <> "": SetGadgetText(#GADGET_Prefs_LccLib, Text$): EndIf            
            
            Case #GADGET_Prefs_GetLibMaker
              Text$ = OpenFileRequester("Select LibraryMaker.exe ...", GetGadgetText(#GADGET_Prefs_LibMaker), "Exe Files (*.exe)|*.exe|All Files (*.*)|*.*", 0)
              If Text$ <> "": SetGadgetText(#GADGET_Prefs_LibMaker, Text$): EndIf            
            
            Case #GADGET_Prefs_GetTemp
              Text$ = PathRequester("Select Temp Path...", GetGadgetText(#GADGET_Prefs_Temp))
              If Text$ <> "": SetGadgetText(#GADGET_Prefs_Temp, Text$): EndIf
            
            Case #GADGET_Prefs_GetUserLib            
              Text$ = PathRequester("Select UserLibraries Path...", GetGadgetText(#GADGET_Prefs_UserLib))
              If Text$ <> "": SetGadgetText(#GADGET_Prefs_UserLib, Text$): EndIf              
          
          EndSelect
        EndIf
        
      ;- Compiler Options events
      Case #WINDOW_Options
        If EventID = #PB_EventCloseWindow
          EnableWindow_(*MainWindow, #TRUE)
          EnableWindow_(WindowID(#WINDOW_Browser), #TRUE)
          EnableWindow_(WindowID(#WINDOW_Output), #TRUE)
          CloseWindow(#WINDOW_Options)
        
        ElseIf EventID = #PB_EventMenu
          Select EventMenuID()
            Case #MENU_Shortcut_Return
              File()\DescFile$      = GetGadgetText(#GADGET_Opt_Desc)
              File()\Define$        = GetGadgetText(#GADGET_Opt_Define)
              File()\Compress       = GetGadgetState(#GADGET_Opt_Compress)
              File()\WriteInfo      = GetGadgetState(#GADGET_Opt_WriteInfo)
              File()\UsedFileCount  = CountGadgetItems(#GADGET_Opt_FileList)
              
              For Item = 0 To File()\UsedFileCount-1
                File()\UsedFiles$[Item] = GetGadgetItemText(#GADGET_Opt_FileList, Item, 0)
              Next Item
            
              EnableWindow_(*MainWindow, #TRUE)
              EnableWindow_(WindowID(#WINDOW_Browser), #TRUE)
              EnableWindow_(WindowID(#WINDOW_Output), #TRUE)
              CloseWindow(#WINDOW_Options)   
              SendMessage_(*RichEdit, #EM_SETMODIFY, #TRUE, 0)
        
            
            Case #MENU_Shortcut_Escape
              EnableWindow_(*MainWindow, #TRUE)
              EnableWindow_(WindowID(#WINDOW_Browser), #TRUE)
              EnableWindow_(WindowID(#WINDOW_Output), #TRUE)
              CloseWindow(#WINDOW_Options)
            
          EndSelect
          
        ElseIf EventID = #PB_EventGadget
          Select EventGadgetID()
          
            Case #GADGET_Opt_Use
              File()\DescFile$      = GetGadgetText(#GADGET_Opt_Desc)
              File()\Define$        = GetGadgetText(#GADGET_Opt_Define)
              File()\Compress       = GetGadgetState(#GADGET_Opt_Compress)
              File()\WriteInfo      = GetGadgetState(#GADGET_Opt_WriteInfo)
              File()\UsedFileCount  = CountGadgetItems(#GADGET_Opt_FileList)
              
              For Item = 0 To File()\UsedFileCount-1
                File()\UsedFiles$[Item] = GetGadgetItemText(#GADGET_Opt_FileList, Item, 0)
              Next Item
            
              EnableWindow_(*MainWindow, #TRUE)
              EnableWindow_(WindowID(#WINDOW_Browser), #TRUE)
              EnableWindow_(WindowID(#WINDOW_Output), #TRUE)
              CloseWindow(#WINDOW_Options)
              SendMessage_(*RichEdit, #EM_SETMODIFY, #TRUE, 0)
            
            Case #GADGET_Opt_Abort            
              EnableWindow_(*MainWindow, #TRUE)
              EnableWindow_(WindowID(#WINDOW_Browser), #TRUE)
              EnableWindow_(WindowID(#WINDOW_Output), #TRUE)
              CloseWindow(#WINDOW_Options)

              
            Case #GADGET_Opt_GetDesc
              File$ = GetGadgetText(#GADGET_Opt_Desc)
              If File$ = "": File$ = GetPathPart(CurrentFile$): EndIf
              File$ = OpenFileRequester("Choose .Desc File...",File$, "Desc Files (*.desc)|*.desc|All Files (*.*)|*.*", 0)
              If File$ <> "": SetGadgetText(#GADGET_Opt_Desc, File$): EndIf             
            
            Case #GADGET_Opt_GetFile
              If File$ = "": File$ = GetPathPart(CurrentFile$): EndIf
              File$ = OpenFileRequester("Choose File to add...",File$, "C Files (*.c)|*.c|C Headers (*.h)|*.h|All Files (*.*)|*.*", LastSelectedPattern)
              LastSelectedPattern = SelectedFilePattern()
              
              If File$ <> ""
                If UCase(Left(File$, Len(GetPathPart(CurrentFile$)))) = UCase(GetPathPart(CurrentFile$))
                  File$ = Right(File$, Len(File$)-Len(GetPathPart(CurrentFile$)))
                EndIf
                SetGadgetText(#GADGET_Opt_File, File$)
              EndIf
            
            Case #GADGET_Opt_Add
              If CountGadgetItems(#GADGET_Opt_FileList) < #MAX_FILES
                File$ = GetGadgetText(#GADGET_Opt_File)
                If File$ <> ""                
                  If File$ = File()\FullFileName$ Or File$ = GetFilePart(File()\FullFileName$)
                    MessageRequester("LibraryDesigner","Can't add the SourceFile itself to this list!",#MB_ICONWARNING)
                  Else
                    AddGadgetItem(#GADGET_Opt_FileList, -1, File$)                  
                    SetGadgetText(#GADGET_Opt_File, "")
                  EndIf
                EndIf
              Else
                MessageRequester("LibraryDesigner","Sorry, can't add more than "+Str(#MAX_FILES)+" Files.",#MB_ICONWARNING)
              EndIf
            
            Case #GADGET_Opt_Remove
              Item = GetGadgetState(#GADGET_Opt_FileList)
              If Item <> -1
                RemoveGadgetItem(#GADGET_Opt_FileList, Item)
              EndIf
          
          EndSelect
        EndIf
    
    EndSelect
    
  Until Quit = 1
  
EndIf



;- Program end

ShowWindow_(*MainWindow, #SW_HIDE)

IsMainMaximized = IsZoomed_(*MainWindow)
If IsMainMaximized 
  ShowWindow_(*MainWindow, #SW_RESTORE)
EndIf

GetWindowRect_(*StatusBar, @StatusRect.RECT)
GetWindowRect_(*ToolBar, @ToolRect.RECT)

UseWindow(#WINDOW_Main)
RealMainX = WindowX()
RealMainY = WindowY()
RealMainWidth = WindowWidth()
RealMainHeight = WindowHeight() 

BrowserOldState = BrowserState
OutputOldState = OutputState
UpdateBrowser(3)
UpdateOutput(3)
  
If CreatePreferences("LibraryDesigner.prefs")
  PreferenceGroup("EDITOR")    
    WritePreferenceLong("MainX", RealMainX)
    WritePreferenceLong("MainY", RealMainY)
    WritePreferenceLong("MainWidth", RealMainWidth)
    WritePreferenceLong("MainHeight", RealMainHeight)
    WritePreferenceLong("IsMainMaximized", IsMainMaximized)
    PreferenceComment("")    
    WritePreferenceLong("BrowserToolX", BrowserToolX)
    WritePreferenceLong("BrowserToolY", BrowserToolY)
    WritePreferenceLong("BrowserToolWidth", BrowserToolWidth)
    WritePreferenceLong("BrowserToolHeight", BrowserToolHeight)
    WritePreferenceLong("BrowserMDIX", BrowserMDIX)
    WritePreferenceLong("BrowserMDIY", BrowserMDIY)
    WritePreferenceLong("BrowserMDIWidth", BrowserMDIWidth)
    WritePreferenceLong("BrowserMDIHeight", BrowserMDIHeight)
    WritePreferenceLong("BrowserSplitter", BrowserSplitter)
    WritePreferenceLong("BrowserState", BrowserOldState)
    PreferenceComment("")    
    WritePreferenceLong("OutputToolX", OutputToolX)
    WritePreferenceLong("OutputToolY", OutputToolY)
    WritePreferenceLong("OutputToolWidth", OutputToolWidth)
    WritePreferenceLong("OutputToolHeight", OutputToolHeight)
    WritePreferenceLong("OutputMDIX", OutputMDIX)
    WritePreferenceLong("OutputMDIY", OutputMDIY)
    WritePreferenceLong("OutputMDIWidth", OutputMDIWidth)
    WritePreferenceLong("OutputMDIHeight", OutputMDIHeight)
    WritePreferenceLong("OutputSplitter", OutputSplitter)
    WritePreferenceLong("OutputState", OutputOldState)
    PreferenceComment("")
  PreferenceGroup("PREFS")
    WritePreferenceString("LccPath",LccPath$)
    WritePreferenceString("LccLibPath",LccLibPath$)
    WritePreferenceString("LibMakerPath",LibMakerPath$)
    WritePreferenceString("TempPath",TempPath$)
    WritePreferenceString("UserLibPath",UserLibPath$)
    PreferenceComment("")
  PreferenceGroup("FILES")
    WritePreferenceLong("OpenFiles", OpenFiles)
    WritePreferenceLong("IsChildMaximized", IsChildMaximized)
    For i = 1 To OpenFiles
      WritePreferenceString("File_"+Str(i), LastFiles$(i))
    Next i

  ClosePreferences()
EndIf

End

Procedure CheckSyntax()

  If SaveSources
    If SaveFile(@File()) = #FALSE
      ProcedureReturn
    EndIf
  EndIf
  
  Parameter$ = "-c"
  If File()\Define$ <> ""
    Parameter$ + " -D"+File()\Define$
  EndIf
  
  Parameter$ + " -o -unused -check"
  Parameter$ + " " + GetFilePart(File()\FullFileName$)
  Parameter$ + " -errout="+Chr(34)+TempPath$+"~ld_errors.txt"+Chr(34)
  
  CompilerHandle = RunProgram(LccPath$, Parameter$, GetPathPart(File()\FullFileName$), 2)
  
  If CompilerHandle = 0 
  
    MessageRequester("LibraryDesigner - Compilation","Can't run Lcc.exe, please check the Path in the Preferences", #MB_ICONERROR)
    
  Else
  
    CheckSyntax = #TRUE
    Open_WINDOW_Syntax()
    EnableWindow_(*MainWindow, #FALSE)
    EnableWindow_(WindowID(#WINDOW_Browser), #FALSE) 
    
  EndIf
 
EndProcedure

Procedure CheckSyntaxEnd()

  CheckSyntax = #FALSE  
  EnableWindow_(WindowID(#WINDOW_Browser), #TRUE) 
  EnableWindow_(*MainWindow, #TRUE)
  CloseWindow(#WINDOW_Syntax)  
  
  File()\OutputCount = 0
  ClearGadgetItemList(#GADGET_Output)
  
  If ReadFile(#FILE_ErrorLog, TempPath$+"~ld_errors.txt")
  
    While Eof(#FILE_ErrorLog) = #FALSE
      
      Text$ = ReadString()
      
      Line = -1
      Scan$ = Text$      
      
      If Text$ <> LCase(GetFilePart(File()\FullFileName$))+":"
        If Left(Scan$, 5) = "Error" Or Left(Scan$, 7) = "Warning"
        
          Scan$ = Right(Scan$, Len(Scan$)-FindString(Scan$, " ", 1))
          
          Scan$ = Right(Scan$, Len(Scan$) - Len(GetFilePart(File()\FullFileName$)) - 2)
          Scan$ = Left(Scan$, FindString(Scan$, " ", 1)-1)

          Line = Val(Scan$) - 1
        
        EndIf           
            
        File()\OutputCount + 1
        File()\OutputList$[File()\OutputCount-1] = Text$
        File()\OutputLines[File()\OutputCount-1] = Line
        AddGadgetItem(#GADGET_Output, -1, Text$)
      EndIf
       
    Wend
  
    CloseFile(#FILE_ErrorLog)
  EndIf
  
  DeleteFile(TempPath$+"~ld_errors.txt")
  
EndProcedure

Procedure StartCompilation()

  If SaveSources
    If SaveFile(@File()) = #FALSE
      ProcedureReturn
    EndIf
  EndIf
  
  If File()\DescFile$ = ""
    MessageRequester("LibraryDesigner - Compilation","Please set a .Desc file in the Options first.",#MB_ICONWARNING)
    ProcedureReturn
  EndIf

  Compiling = #TRUE
  TempFiles = 1
  CreatedTempFiles$(1) = "~ld_errors.txt"
  
  CompileFiles = File()\UsedFileCount  + 1 ; current one.
  CompileFiles$(1) = File()\FullFileName$
  
  For i = 0 To File()\UsedFileCount -1
    If Mid(File()\UsedFiles$[i], 2, 2) = ":\"
      CompileFiles$(i+2) = File()\UsedFiles$[i]
    Else
      CompileFiles$(i+2) = GetPathPart(File()\FullFileName$) + File()\UsedFiles$[i]
    EndIf
  Next i
  
  CompileLibName$ = Left(GetFilePart(File()\DescFile$), Len(GetFilePart(File()\DescFile$))-4) + "lib"
  
  CurrentFile = 1
  
  Open_WINDOW_Compiler()
  EnableWindow_(*MainWindow, #FALSE)
  EnableWindow_(WindowID(#WINDOW_Browser), #FALSE)  
  
  File()\OutputCount = 0
  ClearGadgetItemList(#GADGET_Output)
  If OutputState = 3
    UpdateOutput(1)
  EndIf  
  
  Parameter$ = "-c"
  If File()\Define$ <> ""
    Parameter$ + " -D"+File()\Define$
  EndIf
  
  ObjName$ = GetFilePart(CompileFiles$(CurrentFile))
  ObjName$ = Left(ObjName$, Len(ObjName$)-Len(GetExtensionPart(ObjName$)))+"obj"
  
  ;Parameter$ + " -I"+Chr(34)+Left(GetPathPart(LccPath$), Len(GetPathPart(LccPath$))-4)+"\include"+Chr(34)
  Parameter$ + " -o -unused"
  Parameter$ + " " + GetFilePart(CompileFiles$(CurrentFile))
  Parameter$ + " -Fo"+Chr(34)+TempPath$+ObjName$+Chr(34)
  Parameter$ + " -errout="+Chr(34)+TempPath$+"~ld_errors.txt"+Chr(34)
  
  CompilerHandle = RunProgram(LccPath$, Parameter$, GetPathPart(CompileFiles$(CurrentFile)), 2)
  
  If CompilerHandle
  
    TempFiles + 1
    CreatedTempFiles$(TempFiles) = ObjName$
    
    Text$ = "Compiling File: "+GetFilePart(CompileFiles$(CurrentFile))
        
    File()\OutputCount + 1
    File()\OutputList$[File()\OutputCount-1] = Text$
    File()\OutputLines[File()\OutputCount-1] = -1
    AddGadgetItem(#GADGET_Output, -1, Text$)
    
    SetGadgetText(#GADGET_Compiler_Info, Text$)
    
  Else
  
    MessageRequester("LibraryDesigner - Compilation","Can't run Lcc.exe, please check the Path in the Preferences", #MB_ICONERROR)
    StopCompilation("Can't execute 'Lcc.exe' - Please check the Path in the Preferences")      
    
  EndIf
  
  CompileStatus = 1 ; compile sources
   
EndProcedure

Procedure ContinueCompilation()

  If CompileStatus = 1
  
    ObjName$ = GetFilePart(CompileFiles$(CurrentFile))
    ObjName$ = Left(ObjName$, Len(ObjName$)-Len(GetExtensionPart(ObjName$)))+"obj"
  
    If FileSize(TempPath$ + ObjName$) = -1
    
      MessageRequester("LibraryDesigner - Compilation","Failed to compile the file '"+GetFilePart(CompileFiles$(CurrentFile))+"'"+Chr(13)+"Compilation aborted!", #MB_ICONERROR)
      StopCompilation("Failed To compile the file '"+GetFilePart(CompileFiles$(CurrentFile))+"'")
      
    Else
      
      ;- compile next source
      If CurrentFile < CompileFiles ; more files to go...
    
       CurrentFile + 1
        
       Parameter$ = "-c"
        If File()\Define$ <> ""
          Parameter$ + " -D"+File()\Define$
        EndIf
        
        ObjName$ = GetFilePart(CompileFiles$(CurrentFile))
        ObjName$ = Left(ObjName$, Len(ObjName$)-Len(GetExtensionPart(ObjName$)))+"obj"
        
        ;Parameter$ + " -I"+Chr(34)+Left(GetPathPart(LccPath$), Len(GetPathPart(LccPath$))-4)+"\include"+Chr(34)
        Parameter$ + " -o -unused"
        Parameter$ + " " + GetFilePart(CompileFiles$(CurrentFile))
        Parameter$ + " -Fo"+Chr(34)+TempPath$+ObjName$+Chr(34)
        Parameter$ + " -errout="+Chr(34)+TempPath$+"~ld_errors.txt"+Chr(34)
        
        CompilerHandle = RunProgram(LccPath$, Parameter$, GetPathPart(CompileFiles$(CurrentFile)), 2)
        
        If CompilerHandle
        
          TempFiles + 1
          CreatedTempFiles$(TempFiles) = ObjName$
          
          Text$ = "Compiling File: "+GetFilePart(CompileFiles$(CurrentFile))
              
          File()\OutputCount + 1
          File()\OutputList$[File()\OutputCount-1] = Text$
          File()\OutputLines[File()\OutputCount-1] = -1
          AddGadgetItem(#GADGET_Output, -1, Text$)
          
          SetGadgetText(#GADGET_Compiler_Info, Text$)
          
        Else
        
          MessageRequester("LibraryDesigner - Compilation","Can't run Lcc.exe, please check the Path in the Preferences", #MB_ICONERROR)
          StopCompilation("Can't execute 'Lcc.exe' - Please check the Path in the Preferences")      
      
        EndIf
        
      ;- run LccLib
      Else ; last file was compiled successfully, start LccLib now...      
      
        Parameter$ = "/OUT:" + CompileLibName$
        
        For i = 1 To CompileFiles       
          ObjName$ = GetFilePart(CompileFiles$(i))
          ObjName$ = Left(ObjName$, Len(ObjName$)-Len(GetExtensionPart(ObjName$)))+"obj"   
          Parameter$ + " " +ObjName$
        Next i
        
        CompilerHandle = RunProgram(LccLibPath$, Parameter$, TempPath$, 2)
        
        If CompilerHandle
        
          TempFiles + 1
          CreatedTempFiles$(TempFiles) = CompileLibName$
        
          CompileStatus = 2 
          
          Text$ = "Executing LccLib.exe..."
              
          File()\OutputCount + 1
          File()\OutputList$[File()\OutputCount-1] = Text$
          File()\OutputLines[File()\OutputCount-1] = -1
          AddGadgetItem(#GADGET_Output, -1, Text$)
          
          SetGadgetText(#GADGET_Compiler_Info, Text$)      
        
        Else
        
          MessageRequester("LibraryDesigner - Compilation","Can't run LccLib.exe, please check the Path in the Preferences", #MB_ICONERROR)
          StopCompilation("Can't execute 'LccLib.exe' - Please check the Path in the Preferences")      
        
        EndIf
      
      EndIf    
    
    EndIf
  
  ;- Run LibraryMaker
  ElseIf CompileStatus = 2 ; lcclib was run
  
    If FileSize(TempPath$ + CompileLibName$) = -1
    
      MessageRequester("LibraryDesigner - Compilation","Failed to run LccLib - Compilation aborted.", #MB_ICONERROR)
      StopCompilation("Failed to run LccLib - Compilation aborted.")
    
    Else
    
      Desc$ = File()\DescFile$
      If Mid(Desc$, 2, 2) <> ":\"
        Desc$ = GetPathPart(File()\FullFileName$) + Desc$
      EndIf
    
      If CopyFile(Desc$, TempPath$+GetFilePart(Desc$)) = 0
        
        MessageRequester("LibraryDesigner - Compilation","Can't copy the .Desc file to the temp directory! - Compilation aborted!", #MB_ICONERROR)
        StopCompilation("Can't copy the .Desc file to the temp directory! - Compilation aborted!")
      
      Else
      
        TempFiles + 1
        CreatedTempFiles$(TempFiles) = GetFilePart(File()\DescFile$)
      
        Parameter$ = Chr(34)+TempPath$+Chr(34)+" /TO "+Chr(34)+UserLibPath$+Chr(34)
        Parameter$ + " /ALL"
        
        If File()\Compress
          Parameter$ + " /COMPRESSED"
        EndIf
        
        CompilerHandle = RunProgram(LibMakerPath$, Parameter$, GetPathPart(LibMakerPath$), 2)
        
        If CompilerHandle
        
          TempFiles + 1
          CreatedTempFiles$(TempFiles) = CompileLibName$
        
          CompileStatus = 3
          
          Text$ = "Executing LibraryMaker.exe..."
              
          File()\OutputCount + 1
          File()\OutputList$[File()\OutputCount-1] = Text$
          File()\OutputLines[File()\OutputCount-1] = -1
          AddGadgetItem(#GADGET_Output, -1, Text$)
          
          SetGadgetText(#GADGET_Compiler_Info, Text$)      
        
        Else
        
          MessageRequester("LibraryDesigner - Compilation","Can't run LibraryMaker.exe, please check the Path in the Preferences", #MB_ICONERROR)
          StopCompilation("Can't execute 'LibraryMaker.exe' - Please check the Path in the Preferences")      
        
        EndIf        
      
      EndIf

    EndIf
    
  
  ElseIf CompileStatus = 3 ; LibraryMaker was run
  
    If FileSize(UserLibPath$+Left(CompileLibName$, Len(CompileLibName$)-4)) = -1
    
      MessageRequester("LibraryDesigner - Compilation","LibraryMaker Error! Compilation Failed!", #MB_ICONERROR)
      StopCompilation("LibraryMaker Error! Following is the Output of 'PureLibrariesMaker.log'")      
      
      If ReadFile(#FILE_ErrorLog, GetPathPart(LibMakerPath$)+"PureLibrariesMaker.log")
      
        While Eof(#FILE_ErrorLog) = #FALSE
        
          Text$ = ReadString()
              
          File()\OutputCount + 1
          File()\OutputList$[File()\OutputCount-1] = Text$
          File()\OutputLines[File()\OutputCount-1] = -1
          AddGadgetItem(#GADGET_Output, -1, Text$)
          
        Wend
        
        CloseFile(#FILE_ErrorLog)
      
      Else
      
        Text$ = "Cannot read 'PureLibrariesMaker.log'"
            
        File()\OutputCount + 1
        File()\OutputList$[File()\OutputCount-1] = Text$
        File()\OutputLines[File()\OutputCount-1] = -1
        AddGadgetItem(#GADGET_Output, -1, Text$)
      
      EndIf
      
      SetGadgetState(#GADGET_Output, CountGadgetItems(#GADGET_Output)-1)
    
    Else
    
      StopCompilation("Compilation successfull!")
    
    EndIf
  
  EndIf

EndProcedure

Procedure StopCompilation(Message$)

  EnableWindow_(*MainWindow, #TRUE)
  EnableWindow_(WindowID(#WINDOW_Browser), #TRUE)  
  CloseWindow(#WINDOW_Compiler)
  
  File()\OutputCount = 0
  ClearGadgetItemList(#GADGET_Output)
  
  If ReadFile(#FILE_ErrorLog, TempPath$+"~ld_errors.txt")
  
    While Eof(#FILE_ErrorLog) = #FALSE
      
      Text$ = ReadString()
      
      Line = -1
      Scan$ = Text$
      
      HideLine = 0 ; don't display
      For i = 1 To CompileFiles
        If Text$ = LCase(GetFilePart(CompileFiles$(i)))+":"
          HideLine = 1
        EndIf
      Next i        
      
      If HideLine = 0
        If Left(Scan$, 5) = "Error" Or Left(Scan$, 7) = "Warning"
        
          Scan$ = Right(Scan$, Len(Scan$)-FindString(Scan$, " ", 1))
          
          If Left(Scan$, Len(GetFilePart(File()\FullFileName$))) = LCase(GetFilePart(File()\FullFileName$))
          
            Scan$ = Right(Scan$, Len(Scan$) - Len(GetFilePart(File()\FullFileName$)) - 2)
            Scan$ = Left(Scan$, FindString(Scan$, " ", 1)-1)

            Line = Val(Scan$) - 1
          
          EndIf
        
        EndIf           
            
        File()\OutputCount + 1
        File()\OutputList$[File()\OutputCount-1] = Text$
        File()\OutputLines[File()\OutputCount-1] = Line
        AddGadgetItem(#GADGET_Output, -1, Text$)
      EndIf
       
    Wend
  
    CloseFile(#FILE_ErrorLog)
  EndIf

  File()\OutputCount + 1
  File()\OutputList$[File()\OutputCount-1] = ""
  File()\OutputLines[File()\OutputCount-1] = -1
  AddGadgetItem(#GADGET_Output, -1, "")
  
  File()\OutputCount + 1
  File()\OutputList$[File()\OutputCount-1] = Message$
  File()\OutputLines[File()\OutputCount-1] = -1
  AddGadgetItem(#GADGET_Output, -1, Message$)  
  
  SetGadgetState(#GADGET_Output, CountGadgetItems(#GADGET_Output)-1)
  
  If CompilerHandle
    TerminateProcess_(CompilerHandle, 0)
  EndIf
  
  For i = 1 To TempFiles
    DeleteFile(TempPath$ + CreatedTempFiles$(i))
  Next i
    
  Compiling = #FALSE

EndProcedure

Procedure FindText(Mode)
  CallDebugger

  If SearchString$ <> ""
  
    SendMessage_(*RichEdit, #EM_EXGETSEL, 0, @Sel.CHARRANGE)
    
    Find.FINDTEXTEX
    Find\lpstrText = @SearchString$       
   
    If SearchSel
      Find\chrg\cpMin = Sel\cpMin
      Find\chrg\cpMax = Sel\cpMax
      
      SelNew.CHARRANGE     
      SelNew\cpMin = Sel\cpMin
      SelNew\cpMax = Sel\cpMin     
      SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @SelNew.CHARRANGE)
     
    Else
      Find\chrg\cpMin = Sel\cpMin+1
      Find\chrg\cpMax = GetWindowTextLength_(*RichEdit)
   
    EndIf   
   
    Flags = #FR_DOWN
    If SearchCase: Flags | #FR_MATCHCASE: EndIf
    If SearchWords: Flags | #FR_WHOLEWORD: EndIf
    
    Repeat
      Result =  SendMessage_(*RichEdit, #EM_FINDTEXTEX, Flags, @Find) 
      If Result <> -1
        Success = #TRUE
        
        If SearchNoComment And File()\IsCFile
          SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Find\chrgText)
              
          format.CHARFORMAT
          format\cbSize = SizeOf(CHARFORMAT)    
          format\dwMask = #CFM_COLOR      
          SendMessage_(*RichEdit, #EM_GETCHARFORMAT, #SCF_SELECTION, @format)

          If format\crTextColor = #COLOR_Comment       
            Success = #FALSE
          EndIf
          
        EndIf
        
        If SearchNoString      
          Line = SendMessage_(*RichEdit, #EM_EXLINEFROMCHAR, 0, Find\chrgText\cpMin)
          LineStart = SendMessage_(*RichEdit, #EM_LINEINDEX, Line, 0)
          PokeL(*SyntaxBuffer, 2000)
          LineLength = SendMessage_(*RichEdit, #EM_GETLINE, Line, *SyntaxBuffer)
          
          StringMark = 0
          *Pointer.BYTE = *SyntaxBuffer + Find\chrgText\cpMin - LineStart - 1
          
          While *Pointer > *SyntaxBuffer
            If *Pointer\b = '"'
              *Pointer - 1
              If *Pointer\b <> '\'
                StringMark + 1
              EndIf
            Else
              *Pointer - 1
            EndIf
          Wend
          
          If StringMark % 2 = 1  ; result is inside a string.
            Success = #FALSE
          EndIf
        
        EndIf
      
      Else
        Success = #FALSE
      EndIf
      
      If Success
      
        Select Mode
          
          Case 1 ; find
            Line = SendMessage_(*RichEdit, #EM_EXLINEFROMCHAR, 0, Find\chrgText\cpMin)
            SendMessage_(*RichEdit, #EM_LINESCROLL, 0, -20000)
            SendMessage_(*RichEdit, #EM_LINESCROLL, 0, Line-3)
            SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Find\chrgText)
                    
          Case 2 ; replace
            Line = SendMessage_(*RichEdit, #EM_EXLINEFROMCHAR, 0, Find\chrgText\cpMin)
            SendMessage_(*RichEdit, #EM_LINESCROLL, 0, -20000)
            SendMessage_(*RichEdit, #EM_LINESCROLL, 0, Line-3)
            SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Find\chrgText)
            
            SendMessage_(*RichEdit, #EM_REPLACESEL, 0, ReplaceString$)
            Find\chrgText\cpMax = Find\chrgText\cpMin + Len(ReplaceString$)
            SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Find\chrgText)
            HilightLine()
          
          Case 3 ; all
            SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Find\chrgText)            
            SendMessage_(*RichEdit, #EM_REPLACESEL, 0, ReplaceString$)                    
            HilightLine()
        
        EndSelect
        
      EndIf 
      
      If Success        
        Find\chrg\cpMin = Find\chrgText\cpMin + Len(ReplaceString$)
        Sel\cpMax + Len(ReplaceString$) - Len(SearchString$)
        Find\chrg\cpMax = Sel\cpMax
        
      Else
        Find\chrg\cpMin = Find\chrgText\cpMin + Len(SearchString$)
            
      EndIf

    Until Result = -1 Or (Success And Mode <> 3)
    
    If Mode <> 3
      If Success = #FALSE
        SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel.CHARRANGE)
        MessageRequester("LibraryDesigner - Search/Replace","No more matches found!", #MB_ICONINFORMATION)
      EndIf      
    ElseIf Mode = 3 And SearchSel
      SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel.CHARRANGE)
    EndIf
        
    SetFocus_(*RichEdit)
  EndIf

EndProcedure

Procedure ScanBrowser()

  If File()\IsCFile
    
    TotalLength = SendMessage_(*RichEdit, #WM_GETTEXTLENGTH, 0, 0)
    
    *ParserBuffer = AllocateMemory(#MEMORY_Parser, TotalLength+1)
    *ParseBufferEnd = *ParseBuffer + TotalLength
    
    If *ParserBuffer  
      File()\BrowserCount = 0
      
      *StreamTarget = *ParserBuffer
      stream.EDITSTREAM\pfnCallback = @Richedit_StreamToMemory()
      SendMessage_(File()\Richedit, #EM_STREAMOUT, #SF_TEXT, @stream)              
      
      *Pointer.BYTE = *ParserBuffer
      
      LastWord$ = ""
      LastWordLine = 0
      Bracket1Count = 0
      Bracket2Count = 0
      FindState = 0
      CurrentLine = 0
      
      While (*Pointer\b)
        Char.l = *Pointer\b & $FF      
      
        If Char = '/' And PeekB(*Pointer+1) = '*'
          *Pointer + 1
          Repeat
            If *Pointer\b = 0: Break 2: EndIf
            If *Pointer\b = 13: CurrentLine+1: EndIf
            *Pointer + 1
          Until *Pointer\b = '*' And PeekB(*Pointer+1) = '/'
          *Pointer + 2                                      
        
        ElseIf Char = '/' And PeekB(*Pointer+1) = '/'
          *Pointer + 2
          If *Pointer\b = '-' ; marker for the Browser 
            *Start = *Pointer+1
            While *Pointer\b <> 13
              If *Pointer\b = 0: Break 2: EndIf
              *Pointer + 1
            Wend          
            Marker$ = Trim(PeekS(*Start, *Pointer - *Start))
            File()\BrowserList$[File()\BrowserCount] = "> "+Marker$
            File()\BrowserLines[File()\BrowserCount] = CurrentLine
            File()\BrowserCount + 1                         
          Else
            While *Pointer\b <> 13
              If *Pointer\b = 0: Break 2: EndIf
              *Pointer + 1
            Wend
          EndIf
          CurrentLine + 1
          *Pointer + 1
          
        ElseIf Char = '"' ; strings
          Repeat
            If *Pointer\b = 0: Break 2: EndIf
            *Pointer + 1
          Until *Pointer\b = '"' And (PeekB(*Pointer-1) <> '\' Or PeekB(*Pointer-2) = '\')
          *Pointer + 1
          
        ElseIf Char = '(' And Bracket2Count = 0  ; ignore if inside {}
          *Pointer + 1
          Bracket1Count + 1
        
        ElseIf Char = ')' And Bracket2Count = 0
          *Pointer + 1
          Bracket1Count - 1
          If Bracket1Count = 0 
            If  FindState = 1
              FindState = 2 ; got a name and (), only {} needed
            Else
              FindState = 0 ; something else here
            EndIf
            
          ElseIf Bracket1Count < 0 ; obviously a mismatch in ()
            Bracket1Count = 0
            
          EndIf
          
        ElseIf Char = '{' And Bracket1Count = 0 ; ignore inside ()
          *Pointer + 1
          Bracket2Count + 1
          
        ElseIf Char = '}' And Bracket1Count = 0
          *Pointer + 1
          Bracket2Count - 1
          If Bracket2Count = 0 
            If FindState = 2  ; procedure found!
            
              File()\BrowserList$[File()\BrowserCount] = LastWord$
              File()\BrowserLines[File()\BrowserCount] = LastWordLine
              File()\BrowserCount + 1        
              FindState = 0            
              
            Else
              FindState = 0
            EndIf
            
          ElseIf Bracket2Count < 0 ; obviously a mismatch in {}
            Bracket2Count = 0
            
          EndIf
          
        ElseIf Char = 13
          *Pointer + 1
          CurrentLine + 1
          
        ElseIf Char = ' ' Or Char = 10
          *Pointer + 1
          
        ElseIf Bracket1Count = 0 And Bracket2Count = 0 And IsValidChar(Char)
          *Start = *Pointer
          While IsValidChar(*Pointer\b & $FF)         
            *Pointer + 1
          Wend
          FindState = 1
          LastWord$ = PeekS(*Start, *Pointer - *Start)   
          LastWordLine = CurrentLine                          
          
          length = Len(LastWord$)
          For i = 0 To #KeyWords
            If length = KeyWordLength(i) And CompareMemoryString(*Start, @KeyWord$(i), 1, KeyWordLength(i)) = 0
              FindState = 0
              Break
            EndIf
          Next i
        
        ElseIf Bracket1Count = 0 And Bracket2Count = 0
          FindState = 0
          *Pointer + 1
        
        Else
          *Pointer + 1
          
        EndIf
      
      Wend
      
      FreeMemory(#MEMORY_Parser)
      
  
      
      ClearGadgetItemList(#GADGET_Browser)
      For Item = 0 To File()\BrowserCount-1
        AddGadgetItem(#GADGET_Browser, -1, File()\BrowserList$[Item])
      Next Item    
      
    EndIf
    
  EndIf
 
EndProcedure

Procedure RefreshStatusBar()
  
  SendMessage_(*RichEdit, #EM_EXGETSEL, 0, @Sel.CHARRANGE)
  Line = SendMessage_(*RichEdit, #EM_EXLINEFROMCHAR, 0, Sel\cpMin)
  LineStart = SendMessage_(*RichEdit, #EM_LINEINDEX, Line, 0)
  
  StatusBarText(#STATUSBAR, 0, "Line: "+Str(Line)+"   Column: "+Str(Sel\cpMin - LineStart), #PB_StatusBar_Center)
  
  If File()\ChangeIcon = #FALSE And SendMessage_(*RichEdit, #EM_GETMODIFY, 0, 0) 
    Name$ = File()\FileName$ + "*"
    SetWindowText_(File()\MDIWindow, @Name$)
    SendMessage_(File()\MDIWindow, #WM_SETICON, 0, UseImage(#IMAGE_FileChanged))
    DrawMenuBar_(*MainWindow)
    File()\ChangeIcon = #TRUE
  EndIf

EndProcedure

Procedure HilightLine()

  If File()\IsCFile
  
    If File()\TextObject
      TextObject.ITextDocument = File()\TextObject
      TextObject\Undo(#tomSuspend, 0)
    EndIf  
  
    Modified = SendMessage_(*RichEdit, #EM_GETMODIFY, 0, 0)
    SendMessage_(*RichEdit, #EM_EXGETSEL, 0, @UserSelection.CHARRANGE)
    
    Line = SendMessage_(*RichEdit, #EM_EXLINEFROMCHAR, 0, UserSelection\cpMin)
    LineStart = SendMessage_(*RichEdit, #EM_LINEINDEX, Line, 0)
    PokeL(*SyntaxBuffer, 2000)
    LineLength = SendMessage_(*RichEdit, #EM_GETLINE, Line, *SyntaxBuffer)
  
    SendMessage_(*RichEdit, #EM_SETEVENTMASK, 0, 0)
  
    EnableWindow_(*RichEdit, #FALSE)
    SendMessage_(*RichEdit, #EM_HIDESELECTION , #TRUE, 0)
    EnableScrollBar_(*RichEdit, #SB_BOTH, #ESB_DISABLE_BOTH)        
    
    Sel.CHARRANGE
    Sel\cpMin = LineStart
    Sel\cpMax = LineStart
    SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
    
    IsString = #FALSE
    IsComment = #FALSE
    *Pointer.BYTE = *SyntaxBuffer  
        
    Sel\cpMin = LineStart
    Sel\cpMax = LineStart+LineLength
    SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)    
    
    format.CHARFORMAT
    format\cbSize = SizeOf(CHARFORMAT)      
    format\dwMask = #CFM_COLOR
    format\crTextColor = #COLOR_Text
    SendMessage_(*RichEdit, #EM_SETCHARFORMAT, #SCF_SELECTION, @format)    
    
    While *Pointer < *SyntaxBuffer + LineLength
    
      If IsComment        
        If *Pointer\b = '*'
          *Pointer + 1
          If *Pointer\b = '/'
            Sel\cpMin = CommentStart
            Sel\cpMax = *Pointer - *SyntaxBuffer + LineStart
            SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
            
            format\crTextColor = #COLOR_Comment
            SendMessage_(*RichEdit, #EM_SETCHARFORMAT, #SCF_SELECTION, @format)  
            *Pointer + 1
            IsComment = #FALSE
        
          EndIf
        Else
          *Pointer + 1
        EndIf
      
      ElseIf IsString
        If *Pointer\b = '"'
          *Pointer-1
          If *Pointer\b <> '\' Or PeekB(*Pointer-1) = '\'          
            IsString = #FALSE            
          EndIf
          *Pointer+1
        EndIf
        *Pointer + 1
        
      ElseIf *Pointer\b = '"'
        IsString = #TRUE
        *Pointer + 1
      
      ElseIf *Pointer\b = '/'
        *Pointer + 1          
        If *Pointer\b = '/'
          Sel\cpMin = *Pointer - 1 - *SyntaxBuffer + LineStart
          Sel\cpMax = LineStart + LineLength
          SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
          
          format\crTextColor = #COLOR_Comment
          SendMessage_(*RichEdit, #EM_SETCHARFORMAT, #SCF_SELECTION, @format)    
          Break         
        
        ElseIf *Pointer\b = '*'
          CommentStart = *Pointer - 1 - *SyntaxBuffer + LineStart
          IsComment = #TRUE
          *Pointer + 1
        
        EndIf
      
      ElseIf IsValidChar(*Pointer\b & $FF)
        *Start = *Pointer
        
        While IsValidChar(*Pointer\b & $FF)
          *Pointer + 1
        Wend
        
        Length = *Pointer - *Start
        For i = 0 To #KeyWords
          
          If KeyWordLength(i) = Length
            If CompareMemoryString(*Start, @KeyWord$(i), 0, KeyWordLength(i)) = 0

              Sel\cpMin = *Start - *SyntaxBuffer + LineStart
              Sel\CpMax = Sel\cpMin + KeywordLength(i)
              SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
              
              format\crTextColor = #COLOR_KeyWord
              SendMessage_(*RichEdit, #EM_SETCHARFORMAT, #SCF_SELECTION, @format) 
              
              Break
            EndIf
          EndIf
          
        Next i
      
      Else
        *Pointer + 1
        
      EndIf

    Wend  
    
    If IsComment
      Sel\cpMin = CommentStart
      Sel\cpMax = LineStart + LineLength
      SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
      
      format\crTextColor = #COLOR_Comment
      SendMessage_(*RichEdit, #EM_SETCHARFORMAT, #SCF_SELECTION, @format)          
    EndIf
  
    EnableScrollBar_(*RichEdit, #SB_BOTH, #ESB_ENABLE_BOTH)
    SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @UserSelection)
    SendMessage_(*RichEdit, #EM_HIDESELECTION , #FALSE, 0)
    EnableWindow_(*RichEdit, #TRUE)
    
    SendMessage_(*RichEdit, #EM_SETEVENTMASK, 0, #ENM_KEYEVENTS|#ENM_MOUSEEVENTS|#ENM_SELCHANGE)
    SetFocus_(*RichEdit)
    
    SendMessage_(*RichEdit, #EM_SETMODIFY, Modified, 0)
    
    If File()\TextObject
      TextObject\Undo(#tomResume, 0)
    EndIf  
    
    SetFocus_(*RichEdit)
    
  EndIf

EndProcedure

Procedure HilightFile()

  If File()\TextObject
    TextObject.ITextDocument = File()\TextObject
    TextObject\Undo(#tomSuspend, 0)
  EndIf

  Modified = SendMessage_(*RichEdit, #EM_GETMODIFY, 0, 0) 

  SendMessage_(*RichEdit, #EM_SETEVENTMASK, 0, 0)
    
  EnableWindow_(*RichEdit, #FALSE)
  SendMessage_(*RichEdit, #EM_HIDESELECTION , #TRUE, 0)
  SendMessage_(*RichEdit, #EM_EXGETSEL, 0, @UserSelection.CHARRANGE)
  EnableScrollBar_(*RichEdit, #SB_BOTH, #ESB_DISABLE_BOTH)
  
  Sel.CHARRANGE
  Sel\cpMin = 0
  Sel\cpMax = -1
  SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
  
  format.CHARFORMAT
  format\cbSize = SizeOf(CHARFORMAT)    
  format\dwMask = #CFM_COLOR      
  format\crTextColor = #COLOR_Text
  SendMessage_(*RichEdit, #EM_SETCHARFORMAT, #SCF_SELECTION, @format) 
    

  If File()\IsCFile
  
    MaxLine = SendMessage_(*RichEdit, #EM_GETLINECOUNT, 0, 0) - 1
    IsComment = #FALSE
    
    For Line = 0 To MaxLine
      
      LineStart = SendMessage_(*RichEdit, #EM_LINEINDEX, Line, 0)      
      
      PokeL(*SyntaxBuffer, 2000)
      LineLength = SendMessage_(*RichEdit, #EM_GETLINE, Line, *SyntaxBuffer)
      
      IsString = #FALSE
      *Pointer.BYTE = *SyntaxBuffer
      
      ;- load info block
      If LoadingFile  ; check for the info block
        If CompareMemoryString(*SyntaxBuffer, @"/* {==LibraryDesigner InfoStart==}", 1, 34) = 0
          File()\WriteInfo = #TRUE
        
          OldLineStart = SendMessage_(*RichEdit, #EM_LINEINDEX, Line-1, 0) 
          Sel\cpMin = OldLineStart + SendMessage_(*RichEdit, #EM_LINELENGTH, OldLineStart, 0)         
          
          For Line = Line To MaxLine
            LineStart = SendMessage_(*RichEdit, #EM_LINEINDEX, Line, 0) 
            PokeL(*SyntaxBuffer, 2000)
            LineLength = SendMessage_(*RichEdit, #EM_GETLINE, Line, *SyntaxBuffer)
            
            LineText$ = PeekS(*SyntaxBuffer, LineLength) 
            LineText$ = RemoveString(LineText$, Chr(13))
            LineText$ = RemoveString(LineText$, Chr(10))                                                           
            Search$   = UCase(RemoveString(LineText$, " "))
            Search$   = StringField(RemoveString(Search$, Chr(9)), 1, "=")
            search$   = RemoveString(Search$, "*")
            
            If Search$ = "DESC"
              File()\DescFile$ = Trim(StringField(LineText$, 2, "="))
              
            ElseIf Search$ = "DEFINE" 
              File()\Define$ = Trim(StringField(LineText$, 2, "="))             
              
            ElseIf Search$ = "COMPRESS"
              File()\Compress = Val(Trim(StringField(LineText$, 2, "=")))
            
            ElseIf Search$ = "USEDFILES"
              File()\UsedFileCount = Val(Trim(StringField(LineText$, 2, "=")))
              
            ElseIf Left(Search$, 4) = "FILE"
              Number = Val(Right(Search$, Len(Search$)-4))
              File()\UsedFiles$[Number] = Trim(StringField(LineText$, 2, "="))
              
            ElseIf Search$ = "/"
              If Trim(LineText$) = "*/" ; end of block
              
                Sel\cpMax = LineStart + LineLength
                SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
                SendMessage_(*RichEdit, #EM_REPLACESEL, #FALSE, @"") ; remove block
                
                If Line < MaxLine  ; initialize new syntax line
                  Line + 1
                  LineStart = SendMessage_(*RichEdit, #EM_LINEINDEX, Line, 0) 
                  PokeL(*SyntaxBuffer, 2000)
                  LineLength = SendMessage_(*RichEdit, #EM_GETLINE, Line, *SyntaxBuffer)
                EndIf
                
                Break
              EndIf  
            
            EndIf
                        
          Next Line
                      
        EndIf
               
      EndIf
      
      While *Pointer < *SyntaxBuffer + LineLength
      
        If *Pointer\b = 9  ; remove all TAB
          RtlMoveMemory_(*Pointer+2, *Pointer+1, LineLength - (*Pointer-*SyntaxBuffer))
          LineLength + 1
          Sel\cpMin = *Pointer - *SyntaxBuffer + LineStart
          Sel\cpMax = Sel\cpMin + 1
          SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
          SendMessage_(*RichEdit, #EM_REPLACESEL, #FALSE, @"  ")
          *Pointer\b = ' '
          PokeB(*Pointer+1, ' ')
        EndIf
      
        If IsComment          
          If *Pointer\b = '*'
            *Pointer + 1
            If *Pointer\b = '/'
          
              Sel\cpMin = CommentStart
              Sel\cpMax = *Pointer - *SyntaxBuffer + LineStart
              SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
              
              format\crTextColor = #COLOR_Comment
              SendMessage_(*RichEdit, #EM_SETCHARFORMAT, #SCF_SELECTION, @format)  
              *Pointer + 1
              IsComment = #FALSE
          
            EndIf
          Else
            *Pointer + 1
          EndIf
        
        ElseIf IsString
          If *Pointer\b = '"'
            *Pointer-1
            If *Pointer\b <> '\' Or PeekB(*Pointer-1) = '\'         
              IsString = #FALSE            
            EndIf
            *Pointer+1
          EndIf
          *Pointer + 1
          
        ElseIf *Pointer\b = '"'
          IsString = #TRUE
          *Pointer + 1
        
        ElseIf *Pointer\b = '/'
          *Pointer + 1          
          If *Pointer\b = '/'
            Sel\cpMin = *Pointer - 1 - *SyntaxBuffer + LineStart
            Sel\cpMax = LineStart + LineLength
            SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
            
            format\crTextColor = #COLOR_Comment
            SendMessage_(*RichEdit, #EM_SETCHARFORMAT, #SCF_SELECTION, @format)    
            Break         
          
          ElseIf *Pointer\b = '*'
            CommentStart = *Pointer - 1 - *SyntaxBuffer + LineStart
            IsComment = #TRUE
            *Pointer + 1
          
          EndIf
        
        ElseIf IsValidChar(*Pointer\b & $FF)
          *Start = *Pointer
          
          While IsValidChar(*Pointer\b & $FF)
            *Pointer + 1
          Wend
          
          Length = *Pointer - *Start
          For i = 0 To #KeyWords
            
            If KeyWordLength(i) = Length
              If CompareMemoryString(*Start, @KeyWord$(i), 0, KeyWordLength(i)) = 0

                Sel\cpMin = *Start - *SyntaxBuffer + LineStart
                Sel\CpMax = Sel\cpMin + KeywordLength(i)
                SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
                
                format\crTextColor = #COLOR_KeyWord
                SendMessage_(*RichEdit, #EM_SETCHARFORMAT, #SCF_SELECTION, @format) 
                
                Break
              EndIf
            EndIf
            
          Next i
        
        Else
          *Pointer + 1
          
        EndIf

      Wend
      
    Next Line       
  
  EndIf
  
  EnableScrollBar_(*RichEdit, #SB_BOTH, #ESB_ENABLE_BOTH)
  SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @UserSelection)
  SendMessage_(*RichEdit, #EM_HIDESELECTION , #FALSE, 0)
  EnableWindow_(*RichEdit, #TRUE)
  
  SendMessage_(*RichEdit, #EM_SETEVENTMASK, 0, #ENM_KEYEVENTS|#ENM_MOUSEEVENTS|#ENM_SELCHANGE)
  
  SendMessage_(*RichEdit, #EM_SETMODIFY, Modified, 0)
  
  If File()\TextObject
    TextObject\Undo(#tomResume, 0)
  EndIf  
  
  SetFocus_(*RichEdit)

EndProcedure

Procedure NewFile()
  
  NoCurrentFileUpdate = #TRUE

  AddElement(File())
  File()\FileName$ = "Untitled"
  File()\MDIWindow = CreateWindowEx_(#WS_EX_MDICHILD, @"MDI_ChildClass", @"Untitled", #MDIS_ALLCHILDSTYLES, #CW_USEDEFAULT, #CW_USEDEFAULT, #CW_USEDEFAULT, #CW_USEDEFAULT, *ClientWindow, #NULL, GetModuleHandle_(0), #NULL)
  File()\IsCFile = #TRUE
  
  If File()\MDIWindow = 0
    DeleteElement(File())
    MessageRequester("LibraryDesigner","Can't open new File!")
    ProcedureReturn
  EndIf
  
  File()\Richedit = CreateWindowEx_(#WS_EX_CLIENTEDGE, "RichEdit20A", 0, #ES_NOHIDESEL|#WS_CHILD|#WS_VISIBLE|#ES_MULTILINE|#ES_AUTOHSCROLL|#ES_AUTOVSCROLL|#ES_WANTRETURN|#WS_HSCROLL|#WS_VSCROLL, 0, 0, 0, 0, File()\MDIWindow, 0, GetModuleHandle_(0), 0)
  
  If SendMessage_(File()\RichEdit, #EM_GETOLEINTERFACE, 0, @OleObject.IRichEditOle)
    File()\OleObject = OleObject    
    If OleObject\QueryInterface(?IID_ITextDocument, @TextObject) <> #E_NOINTERFACE
      File()\TextObject = TextObject
    EndIf
  EndIf
  
  SendMessage_(File()\Richedit, #EM_SETEVENTMASK, 0, #ENM_KEYEVENTS|#ENM_MOUSEEVENTS|#ENM_SELCHANGE)
  SendMessage_(File()\Richedit, #EM_EXLIMITTEXT  , 0, 1000000)
  
  SendMessage_(File()\Richedit, #EM_SETMARGINS,#EC_LEFTMARGIN,3) 
  SendMessage_(File()\Richedit, #WM_SETFONT, UseFont(#FONT), 1)    
  
  SendMessage_(File()\MDIWindow, #WM_SIZE, 0, 0)
  
  SetWindowLong_(File()\MDIWindow, #GWL_USERDATA, @File())
  
  File()\WriteInfo = #TRUE
  
  SendMessage_(File()\Richedit, #EM_SETMODIFY, #TRUE, 0)
  
  SendMessage_(File()\MDIWindow, #WM_SETICON, 0, UseImage(#IMAGE_FileChanged))
  DrawMenuBar_(*MainWindow)
  File()\ChangeIcon = #TRUE
  
  NoCurrentFileUpdate = #FALSE
  
  SetCurrentFile()
  HilightFile()
  
EndProcedure


Procedure LoadFile(FileName$)

  NoCurrentFileUpdate = #TRUE
  
  If ReadFile(#FILE_Load, FileName$) = 0
    MessageRequester("LibraryDesigner","Can't Open File!"+Chr(13)+FileName$)
    ProcedureReturn
  EndIf  
  
  AddElement(File())
  File()\FullFileName$ = FileName$
  File()\FileName$ = GetFilePart(FileName$)
  
  If LCase(GetExtensionPart(File()\FileName$)) = "c" Or LCase(GetExtensionPart(File()\FileName$)) = "h"
    File()\IsCFile = #TRUE
  EndIf
  
  
  File()\MDIWindow = CreateWindowEx_(#WS_EX_MDICHILD, @"MDI_ChildClass", @File()\FileName$, #MDIS_ALLCHILDSTYLES, #CW_USEDEFAULT, #CW_USEDEFAULT, #CW_USEDEFAULT, #CW_USEDEFAULT, *ClientWindow, #NULL, GetModuleHandle_(0), #NULL)
  
  If File()\MDIWindow = 0
    DeleteElement(File())
    MessageRequester("LibraryDesigner","Can't a new MDI Window!")
    CloseFile(#FILE_Load)
    ProcedureReturn
  EndIf  
  
  File()\Richedit = CreateWindowEx_(#WS_EX_CLIENTEDGE, "RichEdit20A", 0, #ES_NOHIDESEL|#WS_CHILD|#WS_VISIBLE|#ES_MULTILINE|#ES_AUTOHSCROLL|#ES_AUTOVSCROLL|#ES_WANTRETURN|#WS_HSCROLL|#WS_VSCROLL, 0, 0, 0, 0, File()\MDIWindow, 0, GetModuleHandle_(0), 0)
  
  If SendMessage_(File()\RichEdit, #EM_GETOLEINTERFACE, 0, @OleObject.IRichEditOle)
    File()\OleObject = OleObject    
    If OleObject\QueryInterface(?IID_ITextDocument, @TextObject) <> #E_NOINTERFACE
      File()\TextObject = TextObject
    EndIf
  EndIf  
  
  SendMessage_(File()\Richedit, #EM_SETEVENTMASK, 0, #ENM_KEYEVENTS|#ENM_MOUSEEVENTS|#ENM_SELCHANGE)
  SendMessage_(File()\Richedit, #EM_SETMARGINS,#EC_LEFTMARGIN,3) 
  SendMessage_(File()\Richedit, #WM_SETFONT, UseFont(#FONT), 1)
  SendMessage_(File()\Richedit, #EM_EXLIMITTEXT  , 0, 1000000)
  
  SendMessage_(File()\MDIWindow, #WM_SIZE, 0, 0)
  
  SetWindowLong_(File()\MDIWindow, #GWL_USERDATA, @File())        
  
  stream.EDITSTREAM\pfnCallback = @Richedit_StreamCallback()
  stream\dwCookie = #TRUE
  SendMessage_(File()\Richedit, #EM_STREAMIN, #SF_TEXT, @stream)
  
  CloseFile(#FILE_Load)  
  
  SendMessage_(File()\Richedit, #EM_SETMODIFY, #FALSE, 0)
  
  NoCurrentFileUpdate = #FALSE
  
  SetCurrentFile()
  
  LoadingFile = #TRUE
  HilightFile()
  LoadingFile = #FALSE  
  
  ScanBrowser()

EndProcedure


Procedure SaveFile(*File.FileInfo)  
  If CreateFile(#FILE_Save, *File\FullFileName$) = 0
    MessageRequester("LibraryDesigner","Can't Save File!"+Chr(13)+*File\FullFileName$)
    ProcedureReturn #FALSE
  EndIf
   
  stream.EDITSTREAM\pfnCallback = @Richedit_StreamCallback()
  stream\dwCookie = #FALSE
  SendMessage_(File()\Richedit, #EM_STREAMOUT, #SF_TEXT, @stream)  
  
  If *File\IsCFile And *File()\WriteInfo ; add information tags    
    UseFile(#FILE_Save)
    
    WriteStringN("")
    WriteStringN("/* {==LibraryDesigner InfoStart==}")
    
    WriteStringN(" * USEDFILES = "+Str(File()\UsedFileCount))
    
    For i = 0 To File()\UsedFileCount-1
    WriteStringN(" * FILE"+Str(i)+Space(6-Len(Str(i)))+"= "+File()\UsedFiles$[i])
    Next i
    
    WriteStringN(" * DESC      = "+File()\DescFile$)
    WriteStringN(" * DEFINE    = "+File()\Define$)
    WriteStringN(" * COMPRESS  = "+Str(File()\compress))
    
    WriteStringN(" * {==LibraryDesigner InfoEnd==}")    
    WriteString (" */")
  EndIf  
  
  CloseFile(#FILE_Save)    
  
  SendMessage_(*RichEdit, #EM_SETMODIFY, #FALSE, 0)
   
  SetWindowText_(File()\MDIWindow, @File()\FileName$)
  SendMessage_(File()\MDIWindow, #WM_SETICON, 0, UseImage(#IMAGE_File))
  DrawMenuBar_(*MainWindow)
  File()\ChangeIcon = #FALSE
  
  ProcedureReturn #TRUE
EndProcedure


Procedure SaveFileAs(*File.FileInfo)

  File$ = SaveFileRequester("Save File...", GetPathPart(CurrentFile$), "C Files (*.c)|*.c|C Headers (*.h)|*.h|All Files (*.*)|*.*", LastSelectedPattern)
  LastSelectedPattern = SelectedFilePattern()
  
  If File$ <> ""    
    If LastSelectedPattern = 0 And GetExtensionPart(File$) = "": File$ + ".c": EndIf
    If LastSelectedPattern = 1 And GetExtensionPart(File$) = "": File$ + ".h": EndIf
    
    If FileSize(File$) <> -1
      Result = MessageRequester("LibraryDesigner","The File '"+File$+"' does allready exist."+Chr(13)+"Do you want to overwrite it?",#MB_ICONWARNING|#PB_Messagerequester_YesNoCancel) 
      If Result = #IDCANCEL
        ProcedureReturn #FALSE        
      ElseIf Result = #IDNO
        ProcedureReturn SaveFileAs(*File)
      EndIf
    EndIf
    
    *File\FullFileName$ = File$
    *File\FileName$ = GetFilePart(File$)
    
    If LCase(GetExtensionPart(File$)) = "c" Or LCase(GetExtensionPart(File$)) = "h"
      *File()\IsCFile = #TRUE
    Else
      *File()\IsCFile = #FALSE
    EndIf
    
    SetWindowText_(*File\MDIWindow, @*File\FileName$)
    
    ProcedureReturn SaveFile(*File)
    
  Else
    ProcedureReturn #FALSE
  EndIf     

EndProcedure


Procedure RemoveFile(*File.FileInfo)

  If *File\OleObject
    OleObject.IRichEditOle = *File\OleObject
    OleObject\Release()
  EndIf

  DestroyWindow_(*File\Richedit)
  SendMessage_(*ClientWindow, #WM_MDIDESTROY, *File\MDIWindow, 0)
  
  ChangeCurrentElement(File(), *File)
  
  If File()\FullFileName$ <> ""
    OpenFiles + 1
    LastFiles$(OpenFiles) = File()\FullFileName$
  EndIf
  
  DeleteElement(File())
  
  SetCurrentFile()

EndProcedure


Procedure SetCurrentFile()
  If NoCurrentFileUpdate = #FALSE
  
    *Window = SendMessage_(*ClientWindow, #WM_MDIGETACTIVE, 0, 0)
    
    ClearGadgetItemList(#GADGET_Browser)
    ClearGadgetItemList(#GADGET_Output)
    
    DisableMenuItem(#MENU_Compiler_Compile,1)
    DisableMenuItem(#MENU_Compiler_Check,1)
    DisableMenuItem(#MENU_Compiler_Options,1)
    DisableToolBarButton(#MENU_Edit_Find,1)
    DisableToolBarButton(#MENU_Compiler_Compile,1)
    DisableToolBarButton(#MENU_Compiler_Check,1)
    DisableToolBarButton(#MENU_Compiler_Options,1)
    
    If *Window = 0 Or CountList(File()) = 0
      DisableMenuItem(#MENU_File_Save,1)
      DisableMenuItem(#MENU_File_SaveAs,1)
      DisableMenuItem(#MENU_File_Close,1)
      DisableMenuItem(#MENU_File_CloseAll,1)
      DisableMenuItem(#MENU_Edit_Undo,1)
      DisableMenuItem(#MENU_Edit_Redo,1)
      DisableMenuItem(#MENU_Edit_Cut,1)
      DisableMenuItem(#MENU_Edit_Copy,1)
      DisableMenuItem(#MENU_Edit_Paste,1)
      DisableMenuItem(#MENU_Edit_Find,1)
      DisableMenuItem(#MENU_Edit_FindNext,1)
      DisableMenuItem(#MENU_Edit_Refresh,1)
      DisableToolBarButton(#MENU_File_Save,1)
      DisableToolBarButton(#MENU_File_Close,1)
      DisableToolBarButton(#MENU_Edit_Undo,1)
      DisableToolBarButton(#MENU_Edit_Redo,1)
      DisableToolBarButton(#MENU_Edit_Cut,1)
      DisableToolBarButton(#MENU_Edit_Copy,1)
      DisableToolBarButton(#MENU_Edit_Paste,1)
      DisableToolBarButton(#MENU_Edit_Refresh,1)
    
    Else
      DisableMenuItem(#MENU_File_Save,0)
      DisableMenuItem(#MENU_File_SaveAs,0)
      DisableMenuItem(#MENU_File_Close,0)
      DisableMenuItem(#MENU_File_CloseAll,0)
      DisableMenuItem(#MENU_Edit_Undo,0)
      DisableMenuItem(#MENU_Edit_Redo,0)
      DisableMenuItem(#MENU_Edit_Cut,0)
      DisableMenuItem(#MENU_Edit_Copy,0)
      DisableMenuItem(#MENU_Edit_Paste,0)
      DisableMenuItem(#MENU_Edit_Find,0)
      DisableMenuItem(#MENU_Edit_FindNext,0)
      DisableMenuItem(#MENU_Edit_Refresh,0)
      DisableToolBarButton(#MENU_File_Save,0)
      DisableToolBarButton(#MENU_File_Close,0)
      DisableToolBarButton(#MENU_Edit_Undo,0)
      DisableToolBarButton(#MENU_Edit_Redo,0)
      DisableToolBarButton(#MENU_Edit_Cut,0)
      DisableToolBarButton(#MENU_Edit_Copy,0)
      DisableToolBarButton(#MENU_Edit_Paste,0)
      DisableToolBarButton(#MENU_Edit_Find,0)
      DisableToolBarButton(#MENU_Edit_Refresh,0)
      
      *File.FileInfo = GetWindowLong_(*Window, #GWL_USERDATA)
      If *File
        ChangeCurrentElement(File(), *File)
      EndIf      
      
      If *File\IsCFile
        DisableMenuItem(#MENU_Compiler_Compile,0)
        DisableMenuItem(#MENU_Compiler_Check,0)
        DisableMenuItem(#MENU_Compiler_Options,0)
        DisableToolBarButton(#MENU_Compiler_Compile,0)
        DisableToolBarButton(#MENU_Compiler_Check,0)
        DisableToolBarButton(#MENU_Compiler_Options,0)
      EndIf
        
      
      *RichEdit = File()\Richedit
      CurrentFile$ = File()\FullFileName$
      
      RefreshStatusBar()
      
      For Item = 0 To File()\BrowserCount-1
        AddGadgetItem(#GADGET_Browser, -1, File()\BrowserList$[Item])
      Next Item
      
      For Item = 0 To File()\OutputCount-1
        AddGadgetItem(#GADGET_Output, -1, File()\OutputList$[Item])
      Next Item
    
    EndIf

  EndIf
EndProcedure

Procedure UpdateBrowser(NewState)
  
  Select BrowserState
  
    Case -1 ; not initialized    
      OpenWindow(#WINDOW_Browser, 0, 0, 0, 0, #PB_Window_Invisible|#PB_Window_Borderless, "Procedure Browser")
      CreateGadgetList(WindowID(#WINDOW_Browser))
      ListViewGadget(#GADGET_Browser, 0, 0, 0, 0)    
      SetGadgetFont(#GADGET_Browser, UseFont(#FONT))
  
    Case 0 ; ToolWindow
      UseWindow(#WINDOW_Browser)
      BrowserToolX = WindowX()
      BrowserToolY = WindowY()
      BrowserToolWidth = WindowWidth()
      BrowserToolHeight = WindowHeight()
            
      HideWindow(#WINDOW_Browser, #TRUE)
      SetWindowLong_(WindowID(#WINDOW_Browser), #GWL_EXSTYLE, GetWindowLong_(WindowID(#WINDOW_Browser), #GWL_EXSTYLE) & ~#WS_EX_TOOLWINDOW)
      SetWindowLong_(WindowID(#WINDOW_Browser), #GWL_STYLE, GetWindowLong_(WindowID(#WINDOW_Browser), #GWL_STYLE) & ~(#WS_BORDER|#WS_CAPTION|#WS_SYSMENU|#WS_SIZEBOX))            
      SetWindowPos_(WindowID(#WINDOW_Browser), #HWND_TOP, 0, 0, 0, 0, #SWP_NOSIZE|#SWP_NOMOVE)
    
    Case 1 ; Docked
      HideWindow(#WINDOW_Browser, #TRUE)
      SetParent_(WindowID(#WINDOW_Browser), 0)               

    Case 2 ; MDI
      GetWindowRect_(*MDIBrowser, @Window.RECT)
      GetClientRect_(*MDIBrowser, @Client.RECT)
      ShowWindow_(*MDIBrowser, #SW_HIDE)
      HideWindow(#WINDOW_Browser, #TRUE)
      SetParent_(WindowID(#WINDOW_Browser), 0)
      SendMessage_(*ClientWindow, #WM_MDIDESTROY, *MDIBrowser, 0)
      *MDIBrowser = 0
      
      UseWindow(#WINDOW_Main)      
      BrowserMDIX = Window\left - WindowX()
      BrowserMDIY = Window\top - WindowY()
      BrowserMDIWidth = Client\right
      BrowserMDIHeight = Client\bottom
     
    Case 3 ; Hidden    
  EndSelect
  
  SetMenuItemState(#MAINMENU, #MENU_Browser_Tool+BrowserState, #FALSE)
  
  BrowserState = NewState
  SendMessage_(WindowID(#WINDOW_Main), #WM_SIZE, 0, 0)  
  
  Select BrowserState
    
    Case 0 ; ToolWindow      
      SetWindowLong_(WindowID(#WINDOW_Browser), #GWL_EXSTYLE, GetWindowLong_(WindowID(#WINDOW_Browser), #GWL_EXSTYLE) | #WS_EX_TOOLWINDOW)      
      SetWindowLong_(WindowID(#WINDOW_Browser), #GWL_STYLE, GetWindowLong_(WindowID(#WINDOW_Browser), #GWL_STYLE) |#WS_BORDER|#WS_CAPTION|#WS_SYSMENU|#WS_SIZEBOX)
      UseWindow(#WINDOW_Browser)
      MoveWindow(BrowserToolX, BrowserToolY)
      ResizeWindow(BrowserToolWidth, BrowserToolHeight)      
      SetWindowPos_(WindowID(#WINDOW_Browser), #HWND_TOPMOST, 0, 0, 0, 0, #SWP_NOSIZE|#SWP_NOMOVE)
      HideWindow(#WINDOW_Browser, #FALSE)
    
    Case 1 ; Docked
      SetParent_(WindowID(#WINDOW_Browser), WindowID(#WINDOW_Main))  
      SendMessage_(WindowID(#WINDOW_Main), #WM_SIZE, 0, 0)    
      HideWindow(#WINDOW_Browser, #FALSE)       

    Case 2 ; MDI      
      *MDIBrowser = CreateWindowEx_(#WS_EX_MDICHILD, @"MDI_ChildClass", @"Procedure Browser", #MDIS_ALLCHILDSTYLES, BrowserMDIX, BrowserMDIY, BrowserMDIWidth, BrowserMDIHeight, *ClientWindow, #NULL, GEtModuleHandle_(0), #NULL)
      SetParent_(WindowID(#WINDOW_Browser), *MDIBrowser)
      UseWindow(#WINDOW_Browser)
      MoveWindow(0, 0)
      SendMessage_(*MDIBrowser, #WM_SIZE, 0, 0)
      HideWindow(#WINDOW_Browser, #FALSE)
      ShowWindow_(*MDIBrowser, #SW_SHOW)
          
    Case 3 ; Hidden          
  EndSelect  
  
  SetMenuItemState(#MAINMENU, #MENU_Browser_Tool+BrowserState, #TRUE)

EndProcedure


Procedure UpdateOutput(NewState)

  Select OutputState
  
    Case -1 ; not initialized    
      OpenWindow(#WINDOW_Output, 0, 0, 0, 0, #PB_Window_Invisible|#PB_Window_Borderless, "Compiler Output")
      CreateGadgetList(WindowID(#WINDOW_Output))
      ListViewGadget(#GADGET_Output, 0, 0, 0, 0)  
      SetGadgetFont(#GADGET_Output, UseFont(#FONT))  
  
    Case 0 ; ToolWindow
      UseWindow(#WINDOW_Output)
      OutputToolX = WindowX()
      OutputToolY = WindowY()
      OutputToolWidth = WindowWidth()
      OutputToolHeight = WindowHeight()
            
      HideWindow(#WINDOW_Output, #TRUE)
      SetWindowLong_(WindowID(#WINDOW_Output), #GWL_EXSTYLE, GetWindowLong_(WindowID(#WINDOW_Output), #GWL_EXSTYLE) & ~#WS_EX_TOOLWINDOW)
      SetWindowLong_(WindowID(#WINDOW_Output), #GWL_STYLE, GetWindowLong_(WindowID(#WINDOW_Output), #GWL_STYLE) & ~(#WS_BORDER|#WS_CAPTION|#WS_SYSMENU|#WS_SIZEBOX))            
      SetWindowPos_(WindowID(#WINDOW_Output), #HWND_TOP, 0, 0, 0, 0, #SWP_NOSIZE|#SWP_NOMOVE)
    
    Case 1 ; Docked
      HideWindow(#WINDOW_Output, #TRUE)
      SetParent_(WindowID(#WINDOW_Output), 0)               

    Case 2 ; MDI
      GetWindowRect_(*MDIOutput, @Window.RECT)
      GetClientRect_(*MDIOutput, @Client.RECT)
      ShowWindow_(*MDIOutput, #SW_HIDE)
      HideWindow(#WINDOW_Output, #TRUE)
      SetParent_(WindowID(#WINDOW_Output), 0)
      SendMessage_(*ClientWindow, #WM_MDIDESTROY, *MDIOutput, 0)
      *MDIOutput = 0
      
      UseWindow(#WINDOW_Main)      
      OutputMDIX = Window\left - WindowX()
      OutputMDIY = Window\top - WindowY()
      OutputMDIWidth = Client\right
      OutputMDIHeight = Client\bottom
     
    Case 3 ; Hidden    
  EndSelect
  
  SetMenuItemState(#MAINMENU, #MENU_Output_Tool+OutputState, #FALSE)
  
  OutputState = NewState
  SendMessage_(WindowID(#WINDOW_Main), #WM_SIZE, 0, 0)  
  
  Select OutputState
    
    Case 0 ; ToolWindow      
      SetWindowLong_(WindowID(#WINDOW_Output), #GWL_EXSTYLE, GetWindowLong_(WindowID(#WINDOW_Output), #GWL_EXSTYLE) | #WS_EX_TOOLWINDOW)      
      SetWindowLong_(WindowID(#WINDOW_Output), #GWL_STYLE, GetWindowLong_(WindowID(#WINDOW_Output), #GWL_STYLE) |#WS_BORDER|#WS_CAPTION|#WS_SYSMENU|#WS_SIZEBOX)
      UseWindow(#WINDOW_Output)
      MoveWindow(OutputToolX, OutputToolY)
      ResizeWindow(OutputToolWidth, OutputToolHeight)      
      SetWindowPos_(WindowID(#WINDOW_Output), #HWND_TOPMOST, 0, 0, 0, 0, #SWP_NOSIZE|#SWP_NOMOVE)
      HideWindow(#WINDOW_Output, #FALSE)
    
    Case 1 ; Docked
      SetParent_(WindowID(#WINDOW_Output), WindowID(#WINDOW_Main))  
      SendMessage_(WindowID(#WINDOW_Main), #WM_SIZE, 0, 0)    
      HideWindow(#WINDOW_Output, #FALSE)       

    Case 2 ; MDI      
      *MDIOutput = CreateWindowEx_(#WS_EX_MDICHILD, @"MDI_ChildClass", @"Compiler Output", #MDIS_ALLCHILDSTYLES, OutputMDIX, OutputMDIY, OutputMDIWidth, OutputMDIHeight, *ClientWindow, #NULL, GEtModuleHandle_(0), #NULL)
      SetParent_(WindowID(#WINDOW_Output), *MDIOutput)
      UseWindow(#WINDOW_Output)
      MoveWindow(0, 0)
      SendMessage_(*MDIOutput, #WM_SIZE, 0, 0)
      HideWindow(#WINDOW_Output, #FALSE)
      ShowWindow_(*MDIOutput, #SW_SHOW)
          
    Case 3 ; Hidden          
  EndSelect  
  
  SetMenuItemState(#MAINMENU, #MENU_Output_Tool+OutputState, #TRUE)

EndProcedure


Procedure MakeToolWindow(WindowID)
  SetWindowLong_(WindowID(WindowID), #GWL_EXSTYLE, GetWindowLong_(WindowID(WindowID), #GWL_EXSTYLE) | #WS_EX_TOOLWINDOW)      
  Width = WindowWidth()
  Height = WindowHeight()
  ResizeWindow(0, 0)      
  ResizeWindow(Width, Height)      
  SetWindowPos_(WindowID(WindowID), #HWND_TOPMOST, 0, 0, 0, 0, #SWP_NOSIZE|#SWP_NOMOVE)
  HideWindow(WindowID, #FALSE)     
EndProcedure


Procedure.l Enum_CloseFiles(Window, lParam)
  If GetWindow_(Window, #GW_OWNER) ; Check for icon title
    ProcedureReturn #TRUE
  EndIf  
  
  SendMessage_(*ClientWindow, #WM_MDIRESTORE, Window, 0)
  SendMessage_(*ClientWindow, #WM_MDIACTIVATE, Window, 0)  
  SendMessage_(*MainWindow, #WM_COMMAND, #MENU_File_Close, 0)
    
  ProcedureReturn #TRUE
EndProcedure

Procedure.l Richedit_StreamCallback(dwCookie.l, pbBuff.l, cb.l, *pcb.LONG)

  If dwCookie  ; load
    UseFile(#FILE_Load)

    If cb > Lof()-Loc()
      *pcb\l = Lof()-Loc()
    Else
      *pcb\l = cb
    EndIf
      
    ReadData(pbBuff, *pcb\l)
    
  Else ; save
    UseFile(#FILE_Save)
    WriteData(pbBuff, cb)
    *pcb\l = cb
  
  EndIf

  ProcedureReturn 0
EndProcedure

Procedure.l Richedit_StreamToMemory(dwCookie.l, pbBuff.l, cb.l, *pcb.LONG)

  CopyMemory(pbBuff, *StreamTarget, cb)
  *StreamTarget + cb
  *pcb\l = cb

  ProcedureReturn 0
EndProcedure

Procedure WindowCallback(Window, Message, wParam, lParam)
  result = #PB_ProcessPureBasicEvents
  
  If Message = #WM_SIZE
  
    Select Window
      
      Case WindowID(#WINDOW_Browser)
        UseWindow(#WINDOW_Browser)
        ResizeGadget(#GADGET_Browser, 0, 0, WindowWidth(), WindowHeight())
        
      Case WindowID(#WINDOW_Output)
        UseWindow(#WINDOW_Output)
        ResizeGadget(#GADGET_Output, 0, 0, WindowWidth(), WindowHeight())
                
    
    EndSelect
  
  EndIf
  
  ProcedureReturn result
EndProcedure

Procedure MDI_FrameProc(Window, Message, wParam, lParam)
  result = 0
  
  Select Message
  
    Case #WM_CLOSE
      OpenFiles = 0      
      IsChildMaximized = 0
      SendMessage_(*ClientWindow, #WM_MDIGETACTIVE, 0, @IsChildMaximized)      
      EnumChildWindows_(*Clientwindow, @Enum_CloseFiles(), 0)
      If GetWindow_(*ClientWindow, #GW_CHILD) = 0
        Quit = 1
      EndIf      
  
    Case #WM_COMMAND
      If lParam = 0 Or lParam = *Toolbar
        Select wParam & $ffff
        
          ;- Main Menu Events
       
          Case #MENU_File_New
            OpenFiles = 0
            NewFile()
            
          Case #MENU_File_Open
            OpenFiles = 0
            File$ = OpenFileRequester("Open File...", GetPathPart(CurrentFile$), "C Files (*.c)|*.c|C Headers (*.h)|*.h|All Files (*.*)|*.*", LastSelectedPattern)
            LastSelectedPattern = SelectedFilePattern()
            If File$
              LoadFile(File$)
            EndIf
            
          Case #MENU_File_Save
            If File()\FullFileName$ = ""
              SaveFileAs(@File())
              HilightFile()
              ScanBrowser()
            Else
              SaveFile(@File())
            EndIf
            
          Case #MENU_File_SaveAs
            SaveFileAs(@File())
            HilightFile()   
            ScanBrowser()      
            
          Case #MENU_File_Close
            If SendMessage_(*RichEdit, #EM_GETMODIFY, 0, 0)
              Result = MessageRequester("LibraryDesigner","Do you want to save the changes in '"+File()\FileName$+"' ?",#MB_ICONQUESTION|#PB_MessageRequester_YesNoCancel)
              If Result = #IDYES
              
                If File()\FullFileName$ = ""
                  Result = SaveFileAs(@File())
                Else
                  Result = SaveFile(@File())
                EndIf      
                
                If Result
                  RemoveFile(@File())
                EndIf          
                
              ElseIf Result = #IDNO
                RemoveFile(@File())
              EndIf            
            Else
              RemoveFile(@File())
            EndIf
                        
          Case #MENU_File_CloseAll
            OpenFiles = 0
            EnumChildWindows_(*Clientwindow, @Enum_CloseFiles(), 0)
            
          Case #MENU_File_Preferences
            Open_WINDOW_Preferences()
            
          Case #MENU_File_Quit
            OpenFiles = 0 
            IsChildMaximized = 0
            SendMessage_(*ClientWindow, #WM_MDIGETACTIVE, 0, @IsChildMaximized) 
            EnumChildWindows_(*Clientwindow, @Enum_CloseFiles(), 0)
            If GetWindow_(*ClientWindow, #GW_CHILD) = 0
              Quit = 1
            EndIf      
              
          Case #MENU_Edit_Undo
            SendMessage_(*RichEdit, #EM_UNDO, 0, 0)
            
          Case #MENU_Edit_Redo
            SendMessage_(*RichEdit, #EM_REDO, 0, 0)
            
          Case #MENU_Edit_Cut
            SendMessage_(*RichEdit, #WM_CUT, 0, 0)
            ScanBrowser()
            HilightLine()
            
          Case #MENU_Edit_Copy
            SendMessage_(*RichEdit, #WM_COPY, 0, 0)
            
          Case #MENU_Edit_Paste
            SendMEssage_(*RichEdit, #EM_PASTESPECIAL, #CF_TEXT, 0)
            ScanBrowser()
            HilightFile()
            
          Case #MENU_Edit_Refresh
            HilightFile()
            ScanBrowser()
            
          Case #MENU_Edit_Goto
            If WindowID(#WINDOW_Goto) = 0
              Open_WINDOW_Goto()
            EndIf
            
          Case #MENU_Edit_Find
            If WindowID(#WINDOW_Find) = 0
              Open_WINDOW_Find()
            EndIf
            
          Case #MENU_Edit_FindNext
            If SearchString$ = "" And WindowID(#WINDOW_Find) = 0
              Open_WINDOW_Find()
            ElseIf SearchString$ <> ""
              FindText(1)
            EndIf
            
          Case #MENU_Compiler_Compile
            StartCompilation()
            
          Case #MENU_Compiler_Check
            CheckSyntax()
            
          Case #MENU_Compiler_Options
            Open_WINDOW_Options()          
          
          Case #MENU_Output_Tool
            UpdateOutput(0)
            
          Case #MENU_Output_Docked
            UpdateOutput(1)
            
          Case #MENU_Output_Child
            UpdateOutput(2)
            
          Case #MENU_Output_Hide            
            UpdateOutput(3)
          
          Case #MENU_Browser_Tool
            UpdateBrowser(0)
            
          Case #MENU_Browser_Docked
            UpdateBrowser(1)
            
          Case #MENU_Browser_Child
            UpdateBrowser(2)
            
          Case #MENU_Browser_Hide            
            UpdateBrowser(3)     
                        
          Case #MENU_TileVertical
            SendMessage_(*ClientWindow, #WM_MDITILE, #MDITILE_VERTICAL, 0)
            
          Case #MENU_TileHorizontal
            SendMessage_(*ClientWindow, #WM_MDITILE, #MDITILE_HORIZONTAL, 0)
            
          Case #MENU_Cascade  
            SendMessage_(*ClientWindow, #WM_MDICASCADE, #MDITILE_SKIPDISABLED, 0)          
             
        EndSelect
      EndIf
      
      result = DefFrameProc_(*MainWindow, *ClientWindow, Message, wParam, lParam)
    
    
    ;- Splitter Events       
    Case #WM_MOUSEMOVE
      MouseX = lparam & $FFFF
      MouseY = lparam >> 16
      GetClientRect_(Window, @Client.RECT)
      GetWindowRect_(*Toolbar, @ToolbarSize.RECT)
      GetWindowRect_(*StatusBar, @StatusbarSize.RECT)
      MainTop = (ToolbarSize\bottom - ToolbarSize\top)
      Client\bottom - MainTop - (StatusbarSize\bottom - StatusbarSize\top)
      
      If SplitterXActive And MouseX < Client\right - 14 And MouseX > 10
        BrowserSplitter = Client\right - MouseX - 4        
        SetCursor_(SplitterXCursor)
        UseWindow(#WINDOW_Splitter)
        MoveWindow(Client\right-BrowserSplitter-6, MainTop)
      
      ElseIf SplitterYActive And MouseY < MainTop+Client\bottom - 14 And MouseY > MainTop+10
        OutputSplitter = MainTop+Client\bottom - MouseY - 4
        SetCursor_(SplitterYCursor)   
        UseWindow(#WINDOW_Splitter)
        MoveWindow(0, MainTop+Client\bottom-OutputSplitter-6)     
      
      Else
      
        If BrowserState = 1 And MouseX > Client\right-BrowserSplitter-4 And MouseX < Client\right-BrowserSplitter+4
          SetCursor_(SplitterXCursor)
          
        ElseIf OutputState = 1 And MouseY > MainTop+Client\bottom-OutputSplitter-4 And MouseY < MainTop+Client\bottom-OutputSplitter+4
          SetCursor_(SplitterYCursor)
          
        EndIf
      
      EndIf
      
    Case #WM_LBUTTONDOWN
      MouseX = lparam & $FFFF
      MouseY = lparam >> 16
      GetClientRect_(Window, @Client.RECT)    
      GetWindowRect_(*Toolbar, @ToolbarSize.RECT)
      GetWindowRect_(*StatusBar, @StatusbarSize.RECT)
      MainTop = (ToolbarSize\bottom - ToolbarSize\top)
      Client\bottom - MainTop - (StatusbarSize\bottom - StatusbarSize\top)
      
      If BrowserState = 1 And MouseX > Client\right-BrowserSplitter-4 And MouseX < Client\right-BrowserSplitter+4
        SplitterXActive = #TRUE
        SetCapture_(*MainWindow)
        SetCursor_(SplitterXCursor)
        
        UseWindow(#WINDOW_Splitter)
        ResizeWindow(6, Client\bottom)
        MoveWindow(Client\right-BrowserSplitter-6, MainTop)
        HideWindow(#WINDOW_Splitter, #FALSE)
        BringWindowToTop_(WindowID(#WINDOW_Splitter))
        
        
      ElseIf OutputState = 1 And MouseY > MainTop+Client\bottom-OutputSplitter-4 And MouseY < MainTop+Client\bottom-OutputSplitter+4
        SplitterYActive = #TRUE
        SetCapture_(*MainWindow)
        SetCursor_(SplitterYCursor)   
        
        UseWindow(#WINDOW_Splitter)
        
        If BrowserState = 1 ; docked
          ResizeWindow(Client\right-BrowserSplitter-2, 6)
        Else
          ResizeWindow(Client\right, 6)
        EndIf
        MoveWindow(0, MainTop+Client\bottom-OutputSplitter-6)
        HideWindow(#WINDOW_Splitter, #FALSE)
        BringWindowToTop_(WindowID(#WINDOW_Splitter))             
        
      EndIf      
    
    Case #WM_LBUTTONUP
      If SplitterXActive Or SplitterYActive
        ReleaseCapture_()
        SplitterXActive = #FALSE
        SplitterYActive = #FALSE
        HideWindow(#WINDOW_Splitter, #TRUE)
        SendMessage_(*MainWindow, #WM_SIZE, 0, 0)
      EndIf
     
    ;- Resize Event
    Case #WM_SIZE
      UpdateStatusBar(#STATUSBAR)
      SendMessage_(*Toolbar, #TB_AUTOSIZE, 0, 0)
    
      GetClientRect_(Window, @Client.RECT)
      GetWindowRect_(*Toolbar, @ToolbarSize.RECT)
      GetWindowRect_(*StatusBar, @StatusbarSize.RECT)
      MainTop = (ToolbarSize\bottom - ToolbarSize\top)
      MainWidth = Client\right
      MainHeight = Client\bottom - MainTop - (StatusbarSize\bottom - StatusbarSize\top)     
      
      If BrowserState = 1 And OutputState = 1; docked     
        MoveWindow_(*ClientWindow, 0, MainTop, MainWidth-BrowserSplitter-4, MainHeight-OutputSplitter-4, #TRUE)                    
        UseWindow(#WINDOW_Browser)
        MoveWindow(MainWidth-BrowserSplitter, MainTop)  
        ResizeWindow(BrowserSplitter, MainHeight)      
        UseWindow(#WINDOW_Output)
        MoveWindow(0, MainTop+MainHeight-OutputSplitter)
        ResizeWindow(MainWidth-BrowserSplitter-4, OutputSplitter)
        
      ElseIf BrowserState = 1
        MoveWindow_(*ClientWindow, 0, MainTop, MainWidth-BrowserSplitter-4, MainHeight, #TRUE)
        UseWindow(#WINDOW_Browser)
        MoveWindow(MainWidth-BrowserSplitter, MainTop)        
        ResizeWindow(BrowserSplitter, MainHeight)      
        
      ElseIf OutputState = 1
        MoveWindow_(*ClientWindow, 0, MainTop, MainWidth, MainHeight-OutputSplitter-4, #TRUE)
        UseWindow(#WINDOW_Output)
        MoveWindow(0, MainTop+MainHeight-OutputSplitter)        
        ResizeWindow(MainWidth, OutputSplitter)
        
      Else
        MoveWindow_(*ClientWindow, 0, MainTop, MainWidth, MainHeight, #TRUE)
        
      EndIf 
            
     
    Default
      If *ClientWindow
        result = DefFrameProc_(*MainWindow, *ClientWindow, Message, wParam, lParam)
      Else
        result = DefWindowProc_(Window, Message, wParam, lParam)
      EndIf
      
  EndSelect  

  ProcedureReturn result
EndProcedure


Procedure MDI_ChildProc(Window, Message, wParam, lParam)
  result = 0
  
  Select Message
  
    Case #WM_CLOSE     
      If Window = *MDIBrowser
        UpdateBrowser(3) ; hide
        
      ElseIf Window = *MDIOutput
        UpdateOutput(3) ; hide   
        
      Else      
        SendMessage_(*ClientWindow, #WM_MDIACTIVATE, Window, 0)
        PostMessage_(*MainWindow, #WM_COMMAND, #MENU_File_Close, 0)
        
      EndIf
      
    Case #WM_MDIACTIVATE 
      SetCurrentFile()            
    
    ;- Richedit Keyboard Events  
    Case #WM_NOTIFY
      *msg.MSGFILTER = lParam  
      If *msg\nmhdr\hwndfrom = *RichEdit And *msg\nmhdr\code = #EN_SELCHANGE 
        RefreshStatusBar()
          
      ElseIf *msg\nmhdr\hwndfrom = *RichEdit And *msg\nmhdr\code = #EN_MSGFILTER
        RefreshStatusBar()
      
        If *msg\msg = #WM_KEYDOWN
          key = *msg\wParam
          
          If key = #VK_UP Or key = #VK_DOWN Or key = #VK_RIGHT Or key = #VK_LEFT Or key = #VK_NEXT Or key = #VK_PRIOR Or key = #VK_HOME Or key = #VK_END Or key  = #VK_SPACE
            If (GetKeyState_(#VK_SHIFT) & $8000) = 0
              HilightLine()  
            EndIf
            
          ElseIf key = #VK_TAB
            SendMessage_(*RichEdit, #EM_EXGETSEL, 0, @Sel.CHARRANGE)
            Line1 = SendMessage_(*RichEdit, #EM_EXLINEFROMCHAR, 0, Sel\cpMin)
            Line2 = SendMessage_(*RichEdit, #EM_EXLINEFROMCHAR, 0, Sel\cpMax)
            Line2Start = SendMessage_(*RichEdit, #EM_LINEINDEX, Line2, 0)
            
            If Line2Start = Sel\cpMax And Line2 <> Line1 ; CRLF is selected
              Line2 - 1
            EndIf
            
            If Line1 = Line2  ; one line only
              If (Sel\cpMin - Line2Start) % 2 = 0
                Add$ = "  "
              Else 
                Add$ = " "
              EndIf
              SendMessage_(*RichEdit, #EM_REPLACESEL, #FALSE, @Add$)
              Sel\cpMin + Len(Add$)
              Sel\cpMax = Sel\cpMin
              SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
              
            Else
              SendMessage_(*RichEdit, #EM_HIDESELECTION , #TRUE, 0)
              If GetKeyState_(#VK_SHIFT) & $8000
                ShiftMode = 1
              Else
                ShiftMode = 0
              EndIf 
              
              NewSel.CHARRANGE
              For Line = Line1 To Line2
              
                LineStart = SendMessage_(*RichEdit, #EM_LINEINDEX, Line, 0)
                LineLength = SendMessage_(*RichEdit, #EM_LINELENGTH, LineStart, 0)
                
                If ShiftMode = 1
                  NewSel\cpMin = LineStart
                  NewSel\cpMax = LineStart + 2
                  SelText$ = Space(2)
                  SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @NewSel)
                  SendMessage_(*RichEdit, #EM_GETSELTEXT, 0, @SelText$)   
                  
                  If SelText$ = "  "
                    SendMessage_(*RichEdit, #EM_REPLACESEL, #TRUE, @"")
                    Sel\cpMax - 2
                  ElseIf PeekB(@SelText$) = ' ' And PeekB(@SelText$ + 1) <> ' '
                    NewSel\cpMax = LineStart + 1
                    SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @NewSel)
                    SendMessage_(*RichEdit, #EM_REPLACESEL, #TRUE, @"")
                    Sel\cpMax - 1                  
                  EndIf
                  
                Else
                  NewSel\cpMin = LineStart
                  NewSel\cpMax = LineStart
                  SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @NewSel)
                  SendMessage_(*RichEdit, #EM_REPLACESEL, #TRUE, @"  ")
                  Sel\cpMax + 2
                EndIf

              Next Line
              
              SendMessage_(*RichEdit, #EM_EXSETSEL, 0, @Sel)
              SendMessage_(*RichEdit, #EM_HIDESELECTION , #FALSE, 0)
            
            EndIf
            
            
          ElseIf key = #VK_RETURN
            If IgnoreReturnMessage
              IgnoreReturnMessage = #FALSE
              ProcedureReturn DefMDIChildProc_(Window, Message, wParam, lParam)
            EndIf
            
            HilightLine()
            
            SendMessage_(*RichEdit, #EM_EXGETSEL, 0, @Sel.CHARRANGE)
            Line = SendMessage_(*RichEdit, #EM_EXLINEFROMCHAR, 0, Sel\cpMin)
            LineStart = SendMessage_(*RichEdit, #EM_LINEINDEX, Line, 0)
            If LineStart <> Sel\cpMin
              PokeL(*SyntaxBuffer, 2000)
              LineLength = SendMessage_(*RichEdit, #EM_GETLINE, Line, *SyntaxBuffer)            
              *Pointer.BYTE = *SyntaxBuffer
              
              IgnoreReturnMessage = #TRUE
              
              SendMessage_(*RichEdit, #WM_KEYDOWN, #VK_RETURN, 1)
              
              While *Pointer < *SyntaxBuffer + Sel\cpMin - LineStart
                If *Pointer\b <> ' '
                  Break
                EndIf
                SendMessage_(*RichEdit, #WM_CHAR, ' ', 1)
                *Pointer + 1
              Wend                 
              
              HilightLine()
              
              ProcedureReturn -1
            EndIf            
          
          EndIf
          result = DefMDIChildProc_(Window, Message, wParam, lParam)
        
        ElseIf *msg\msg = #WM_KEYUP
          key = *msg\wParam
          If key = #VK_BACK Or key = #VK_CLEAR Or key = #VK_DELETE
            HilightLine()
            ScanBrowser() 
            
          ElseIf key = #VK_RETURN
            HilightLine()
          
          ElseIf key = #VK_UP Or key = #VK_DOWN 
            ScanBrowser() 
            
          EndIf
               
        ElseIf *msg\msg = #WM_CHAR
          key = *msg\wParam 
          
          If IsValidChar(key & $FF)
            HilightLine()
          EndIf
          
          If *msg\wParam = 9 ; remove tab message
            *msg\wParam = 0
            result = 1
          EndIf         
        
        ElseIf *msg\msg = #WM_RBUTTONDOWN
          DisplayPopupMenu(#POPUPMENU, *MainWindow)
            
        
        Else
          result = DefMDIChildProc_(Window, Message, wParam, lParam)
        EndIf
        
      Else
        result = DefMDIChildProc_(Window, Message, wParam, lParam)
      EndIf
              
  
    Case #WM_SIZE     
      If Window = *MDIBrowser
        GetClientRect_(*MDIBrowser, @Client.RECT)
        UseWindow(#WINDOW_Browser)
        ResizeWindow(Client\right, Client\bottom)
        
      ElseIf Window = *MDIOutput
        GetClientRect_(*MDIOutput, @Client.RECT)
        UseWindow(#WINDOW_Output)
        ResizeWindow(Client\right, Client\bottom)
        
      Else
        GetClientRect_(Window, @Client.RECT)
        MoveWindow_(GetWindow_(Window, #GW_CHILD), 0, 0, Client\right, Client\bottom, #TRUE)
      
      EndIf
      
      result = DefMDIChildProc_(Window, Message, wParam, lParam)
    
    Default
      result = DefMDIChildProc_(Window, Message, wParam, lParam)
      
  EndSelect
  
  ProcedureReturn result
EndProcedure


Procedure Open_WINDOW_Preferences()
  If OpenWindow(#WINDOW_Preferences, 382, 230, 505, 336,  #PB_Window_Invisible|#PB_Window_SystemMenu|#PB_Window_TitleBar | #PB_Window_ScreenCentered , "LibraryDesigner - Preferences")
    If CreateGadgetList(WindowID())
      TextGadget(#GADGET, 15, 170, 210, 15, "Temp Path:")
      Frame3DGadget(#GADGET, 5, 0, 495, 300, "")
      StringGadget(#GADGET_Prefs_Lcc, 15, 35, 430, 20, LccPath$)
      ButtonGadget(#GADGET_Prefs_GetLcc, 450, 35, 40, 20, "...")
      TextGadget(#GADGET, 15, 20, 210, 15, "Lcc.exe:")
      StringGadget(#GADGET_Prefs_LibMaker, 15, 135, 430, 20, LibMakerPath$)
      ButtonGadget(#GADGET_Prefs_GetLccLib, 450, 85, 40, 20, "...")
      TextGadget(#GADGET, 15, 120, 210, 15, "PureBasic LibraryMaker:")
      StringGadget(#GADGET_Prefs_LccLib, 15, 85, 430, 20, LccLibPath$)
      ButtonGadget(#GADGET_Prefs_GetLibMaker, 450, 135, 40, 20, "...")
      TextGadget(#GADGET, 15, 70, 210, 15, "Lcclib.exe:")
      StringGadget(#GADGET_Prefs_Temp, 15, 185, 430, 20, TempPath$)
      ButtonGadget(#GADGET_Prefs_GetTemp, 450, 185, 40, 20, "...")
      TextGadget(#GADGET, 15, 220, 210, 15, "PureBasic UserLibraries Path:")
      StringGadget(#GADGET_Prefs_UserLib, 15, 235, 430, 20, UserLibPath$)
      ButtonGadget(#GADGET_Prefs_GetUserLib, 450, 235, 40, 20, "...")
      ButtonGadget(#GADGET_Prefs_Use, 305, 310, 95, 20, "Use", #PB_Button_Default)
      ButtonGadget(#GADGET_Prefs_Abort, 405, 310, 95, 20, "Cancel")
      
      AddKeyboardShortcut(#WINDOW_Preferences, #PB_Shortcut_Return, #MENU_Shortcut_Return)
      AddKeyboardShortcut(#WINDOW_Preferences, #PB_Shortcut_Escape, #MENU_Shortcut_Escape)
      
      MakeToolWindow(#WINDOW_Preferences)
      
    EndIf
  EndIf
EndProcedure


Procedure Open_WINDOW_Options()
  If OpenWindow(#WINDOW_Options, 372, 150, 541, 386,  #PB_Window_Invisible|#PB_Window_SystemMenu|#PB_Window_TitleBar | #PB_Window_ScreenCentered , "LibraryDesigner - Compiler Options")
    If CreateGadgetList(WindowID())
      Frame3DGadget(#GADGET, 5, 0, 530, 355, "")
      TextGadget(#GADGET, 15, 20, 195, 15, "Desc File Path:")
      StringGadget(#GADGET_Opt_Desc, 15, 35, 460, 20, File()\DescFile$)
      ButtonGadget(#GADGET_Opt_GetDesc, 480, 35, 45, 20, "...")
      TextGadget(#GADGET, 15, 70, 185, 15, "Files to include into the Library:")
      ListViewGadget(#GADGET_Opt_FileList, 15, 85, 510, 125)
      StringGadget(#GADGET_Opt_File, 15, 215, 460, 20, "")
      ButtonGadget(#GADGET_Opt_Add, 15, 240, 100, 20, "Add")
      ButtonGadget(#GADGET_Opt_Remove, 120, 240, 100, 20, "Remove")
      ButtonGadget(#GADGET_Opt_GetFile, 480, 215, 45, 20, "...")
      CheckBoxGadget(#GADGET_Opt_Compress, 15, 325, 245, 20, "Compress the PureLibrary")
      TextGadget(#GADGET, 15, 280, 300, 15, "Predefined Symbol:  (passed as #defined to the compiler)")
      StringGadget(#GADGET_Opt_Define, 15, 295, 510, 20, File()\Define$)
      ButtonGadget(#GADGET_Opt_Abort, 435, 360, 100, 20, "Abort")
      ButtonGadget(#GADGET_Opt_Use, 330, 360, 100, 20, "Use", #PB_Button_Default) 
      CheckBoxGadget(#GADGET_Opt_WriteInfo, 10, 360, 250, 20, "Store Options in Source File")
      
      For i = 0 To File()\UsedFileCount-1
        AddGadgetItem(#GADGET_Opt_FileList, -1, File()\UsedFiles$[i])
      Next i
      
      SetGadgetState(#GADGET_Opt_Compress, File()\Compress)
      SetGadgetState(#GADGET_Opt_WriteInfo, File()\WriteInfo)
      
      EnableWindow_(*MainWindow, #FALSE)
      EnableWindow_(WindowID(#WINDOW_Browser), #FALSE)
      EnableWindow_(WindowID(#WINDOW_Output), #FALSE)
      
      AddKeyboardShortcut(#WINDOW_Options, #PB_Shortcut_Return, #MENU_Shortcut_Return)
      AddKeyboardShortcut(#WINDOW_Options, #PB_Shortcut_Escape, #MENU_Shortcut_Escape)
      
      MakeToolWindow(#WINDOW_Options)
      
    EndIf
  EndIf
EndProcedure


Procedure Open_WINDOW_Find()
  If OpenWindow(#WINDOW_Find, 415, 218, 436, 184, #PB_Window_SystemMenu| #PB_Window_Invisible |  #PB_Window_TitleBar | #PB_Window_ScreenCentered , "LibraryDesigner - Search/Replace")
    If CreateGadgetList(WindowID())
      TextGadget(#GADGET, 45, 15, 55, 15, "Search for:")
      StringGadget(#GADGET_Find_String, 105, 10, 320, 20, SearchString$)
      CheckBoxGadget(#GADGET_Find_DoReplace, 15, 45, 85, 15, "Replace with:")
      StringGadget(#GADGET_Find_NewString, 105, 40, 320, 20, ReplaceString$)
      
      ButtonGadget(#GADGET_Find_Next, 15, 150, 99, 25, "Find Next", #PB_Button_Default)
      ButtonGadget(#GADGET_Find_Replace, 118, 150, 99, 25, "Replace")
      ButtonGadget(#GADGET_Find_Replaceall, 221, 150, 99, 25, "Replace All")
      ButtonGadget(#GADGET_Find_Close, 325, 150, 99, 25, "Close")
      
      Frame3DGadget(#GADGET, 105, 70, 320, 70, "", #PB_Frame3D_Single)
      CheckBoxGadget(#GADGET_Find_Case, 115, 75, 100, 15, "Case Sensitive")
      CheckBoxGadget(#GADGET_Find_Words, 115, 95, 115, 15, "Whole Words only")
      CheckBoxGadget(#GADGET_Find_NoComment, 280, 75, 135, 15, "Don't search Comments")
      CheckBoxGadget(#GADGET_Find_NoString, 280, 95, 125, 15, "Don't search Strings")
      CheckBoxGadget(#GADGET_Find_SelOnly, 115, 115, 155, 15, "Search inside Selection only")

      SetGadgetState(#GADGET_Find_DoReplace, SearchDoReplace)
      SetGadgetState(#GADGET_Find_Case, SearchCase)
      SetGadgetState(#GADGET_Find_Words, SearchWords)
      SetGadgetState(#GADGET_Find_NoComment, SearchNoComment)
      SetGadgetState(#GADGET_Find_NoString, SearchNoString)
      SetGadgetState(#GADGET_Find_SelOnly, SearchSel)     
      
      If SearchDoReplace = #FALSE
        DisableGadget(#GADGET_Find_NewString, #TRUE)
        DisableGadget(#GADGET_Find_Replace, #TRUE)
        DisableGadget(#GADGET_Find_Replaceall, #TRUE)
      EndIf
      
      AddKeyboardShortcut(#WINDOW_Find, #PB_Shortcut_Return, #MENU_Shortcut_Return)
      AddKeyboardShortcut(#WINDOW_Find, #PB_Shortcut_Escape, #MENU_Shortcut_Escape)
      
      SendMessage_(GadgetID(#GADGET_Find_String), #EM_SETSEL, 0, -1)
      ActivateGadget(#GADGET_Find_String)
      
      MakeToolWindow(#WINDOW_Find)
      
    EndIf
  EndIf
EndProcedure


Procedure Open_WINDOW_Goto()
  If OpenWindow(#WINDOW_Goto, 392, 318, 176, 68,  #PB_Window_Invisible|#PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered , "Goto")
    If CreateGadgetList(WindowID())
      StringGadget(#GADGET_Goto_Line, 5, 10, 165, 20, "",#PB_String_Numeric)
      ButtonGadget(#GADGET_Goto_Ok, 5, 40, 80, 20, "Ok", #PB_Button_Default)
      ButtonGadget(#GADGET_Goto_Abort, 90, 40, 80, 20, "Cancel")
      
      AddKeyboardShortcut(#WINDOW_Goto, #PB_Shortcut_Return, #MENU_Shortcut_Return)
      AddKeyboardShortcut(#WINDOW_Goto, #PB_Shortcut_Escape, #MENU_Shortcut_Escape)
       
      MakeToolWindow(#WINDOW_Goto)
      
      ActivateGadget(#GADGET_Goto_Line)
    EndIf
  EndIf
EndProcedure


Procedure Open_WINDOW_Compiler()
  If OpenWindow(#WINDOW_Compiler, 358, 376, 294, 121,  #PB_Window_Invisible|#PB_Window_TitleBar | #PB_Window_ScreenCentered , "Compiling....")
    If CreateGadgetList(WindowID())
      Frame3DGadget(#GADGET, 5, 5, 285, 50, "", #PB_Frame3D_Single)
      TextGadget(#GADGET, 10, 20, 275, 15, "Compiling...", #PB_Text_Center)
      TextGadget(#GADGET_Compiler_Info, 5, 60, 285, 35, "", #PB_Text_Border)
      ButtonGadget(#GADGET_Compiler_Abort, 200, 100, 90, 20, "Abort")
      
      MakeToolWindow(#WINDOW_Compiler)
      
    EndIf
  EndIf
EndProcedure

Procedure Open_WINDOW_Syntax()
  If OpenWindow(#WINDOW_Syntax, 445, 217, 210, 68,  #PB_Window_Invisible|#PB_Window_SizeGadget | #PB_Window_TitleBar | #PB_Window_ScreenCentered , "Checking Syntax...")
    If CreateGadgetList(WindowID())
      Frame3DGadget(#GADGET, 5, 5, 200, 60, "", #PB_Frame3D_Single)
      TextGadget(#GADGET, 15, 30, 185, 15, "Checking Syntax...", #PB_Text_Center)
      
      MAkeToolWindow(#WINDOW_Syntax)
      
    EndIf
  EndIf
EndProcedure

;- DataSection
DataSection

  IID_ITextDocument:  ; {8CC497C0-A1DF-11ce-8098-00AA0047BE5D}
    Data.l $8CC497C0
    Data.w $A1DF, $11ce
    Data.b $80, $98, $00, $AA, $00, $47, $BE, $5D

  Image_TileVertical:
    IncludeBinary "Icon\TileVertical.ico"
  Image_TileHorizontal:
    IncludeBinary "Icon\TileHorizontal.ico"
  Image_Cascade:
    IncludeBinary "Icon\Cascade.ico"
  Image_Check:
    IncludeBinary "Icon\Check.ico"
  Image_Compile: 
    IncludeBinary "Icon\Compile.ico"
  Image_File:
    IncludeBinary "Icon\File.ico"
  Image_FileChanged:
    IncludeBinary "Icon\FileChanged.ico"
  Image_Refresh:
    IncludeBinary "Icon\Refresh.ico"
    
  SyntaxList:
    Data$ "#define"
    Data$ "#undef"
    Data$ "#ifdef"
    Data$ "#ifndef"
    Data$ "#else"
    Data$ "#endif"
    Data$ "#include"
    Data$ "typedef"
    Data$ "struct"
    Data$ "enum"
    Data$ "sizeof"
    Data$ "void"
    Data$ "int"
    Data$ "char"
    Data$ "dword"
    Data$ "long"
    Data$ "extern"
    Data$ "static"
    Data$ "union"
    Data$ "return"
    Data$ "if"
    Data$ "else"
    Data$ "do"
    Data$ "while"
    Data$ "switch"
    Data$ "break"
    Data$ "for"
    Data$ "case"
    Data$ "unsigned"
    Data$ "default"

EndDataSection
; ExecutableFormat=Windows
; CursorPosition=3398
; FirstLine=3354
; UseIcon=Icon\LibraryDesigner.ico
; Executable=C:\Documents and Settings\Administrator\My Documents\LibraryDesigner\LibraryDesigner.exe
; DisableDebugger
; EOF